// $Id: Transaction.cpp,v 1.2 2009/02/02 16:56:44 avalassi Exp $

// Include files
#include <iostream>
#include "CoralServerBase/NotImplemented.h"

// Local include files
#include "ConnectionProperties.h"
#include "Transaction.h"
#include "SessionProperties.h"
#include "logger.h"

// Namespace
using namespace coral::CoralAccess;

//-----------------------------------------------------------------------------

Transaction::Transaction( const SessionProperties& sessionProperties )
  : m_sessionProperties( sessionProperties )
  , m_isActive( false )
  , m_isReadOnly( false )
{
  logger << "Create Transaction" << endlog;
}

//-----------------------------------------------------------------------------

Transaction::~Transaction()
{
  logger << "Delete Transaction" << endlog;
}

//-----------------------------------------------------------------------------

void Transaction::start( bool readOnly )
{
  //if ( isActive() ) throw ...;
  if ( readOnly ) logger << "Start RO Transaction" << endlog;
  else logger << "Start RW Transaction" << endlog;
  facade().startTransaction( m_sessionProperties.sessionID(), readOnly ); // may throw
  m_isActive = true;
  m_isReadOnly = readOnly;
}

//-----------------------------------------------------------------------------

void Transaction::commit()
{
  //if ( ! isActive() ) print warning ...;
  logger << "Commit Transaction" << endlog;
  facade().commitTransaction( m_sessionProperties.sessionID() ); // may throw
  m_isActive = false;
  m_isReadOnly = false;
}

//-----------------------------------------------------------------------------

void Transaction::rollback()
{
  throw NotImplemented("Transaction::rollback");
  //if ( ! isActive() ) print warning ...;
  //logger << "Rollback Transaction" << endlog;
  //m_isActive = false;
  //m_isReadOnly = false;
}

//-----------------------------------------------------------------------------

bool Transaction::isActive() const
{
  return m_isActive;
}

//-----------------------------------------------------------------------------

bool Transaction::isReadOnly() const
{
  throw NotImplemented("Transaction::isReadOnly");
  //if ( ! isActive() ) throw ...;
  //return m_isReadOnly;
}

//-----------------------------------------------------------------------------

const coral::ICoralFacade& Transaction::facade() const
{
  return m_sessionProperties.connectionProperties().facade();
}

//-----------------------------------------------------------------------------
