// $Id: QueryMgr.h,v 1.2 2009/02/05 11:34:23 avalassi Exp $
#ifndef CORALSERVER_QUERYMGR_H
#define CORALSERVER_QUERYMGR_H 1

// Include files
#include "RelationalAccess/IQuery.h"
#include "RelationalAccess/ISessionProxy.h"
#include "CoralServerBase/QueryDefinition.h"

namespace coral 
{

  namespace CoralServer 
  {

    /** @class QueryMgr QueryMgr.h
     *
     *  Relational query manager.
     *
     *  @author Andrea Valassi
     *  @date   2007-06-19 (as part of cool::RalQueryMgr)
     *  @date   2008-01-22 (as coral::CoralProtocol::QueryMgr)
     */
    
    class QueryMgr
    {
      
    public:
      
      /// Create a new coral::IQuery from its definition.
      /// A reference to the AttributeList output buffer can be provided.
      static coral::IQuery* newQuery( coral::AttributeList* pDataBuffer,
                                      coral::ISessionProxy& session,
                                      const coral::QueryDefinition& qd );
      
    private:

      /// Fill a coral::IQuery from its definition.
      /// This assumes that the target query is empty.
      static void prepareQuery( coral::IQueryDefinition& query,
                                const coral::QueryDefinition& qd );
      
    }; 
  }
}
#endif // CORALSERVER_QUERYMGR_H
