// $Id: BoostThread_headers.h,v 1.2 2009/02/02 15:32:22 mwache Exp $
#ifndef BOOSTTHREAD_HEADERS_H 
#define BOOSTTHREAD_HEADERS_H 1

// TEMPORARY! This will be fixed in Boost 1.36.0
// See http://svn.boost.org/trac/boost/ticket/1556
// See http://www.nabble.com/-thread--Missing-initializer-warnings-from-gcc-in-1.35.0-td16447467.html

// Disable warnings triggered by the Boost 1.35.0 boost/thread.hpp header
// See http://wiki.services.openoffice.org/wiki/Writing_warning-free_code
// See also http://www.artima.com/cppsource/codestandards.html
// See also http://gcc.gnu.org/onlinedocs/gcc-4.1.1/cpp/System-Headers.html
// See also http://gcc.gnu.org/ml/gcc-help/2007-01/msg00172.html
#if defined __GNUC__
#pragma GCC system_header
#endif

// Include files
#include <boost/thread.hpp>

#include <boost/version.hpp>

#if BOOST_VERSION >= 103600
typedef boost::condition_variable boost_condition;
#else
typedef boost::condition boost_condition;
#endif

#endif // BOOSTTHREAD_HEADERS_H
