// $Id: SocketServer.h,v 1.3 2009/02/09 12:25:45 mwache Exp $
#ifndef CORALSOCKETS_GENERICSOCKETSERVERMT_SLAC_H 
#define CORALSOCKETS_GENERICSOCKETSERVERMT_SLAC_H 1

// Include files
#include <map>

#include "CoralServerBase/IRequestHandler.h"
#include "CoralSockets/BoostThread_headers.h"
#include "CoralSockets/GenericSocketException.h"

namespace coral {

  namespace CoralSockets {

    // Forward declaration
    class ThreadManager;
 
    /** @class SocketServer SocketServer.h
     *
     *  @author Andrea Valassi and Martin Wache
     *  @date   2007-12-23
     */

    class SocketServer {
      public: 
        virtual ~SocketServer();

        /// you have to make sure, that the handler is valid over the lifetime
        /// of the SocketServer
        SocketServer( coral::IRequestHandler& handler,
            const std::string& host, int port,
            int nHandlerThreadsPerSocket=5, bool debug=true );

        /// main loop of socket server
        void run();

        /// signal the server to stop
        void stopServer();

      private:

        /// Standard constructor is private
        SocketServer();

        /// if false, the server will shut down
        bool m_isActive; 

        /// the request handler which is used to handle incomming
        /// requests
        coral::IRequestHandler& m_handler;

        /// connection details
        std::string m_host;
        int m_port;
        int m_nHandlerThreadsPerSocket;

        bool m_debug;

        /// a thread manager
        std::auto_ptr<ThreadManager> m_thrManager;
    };

  }

}
#endif

