// $Id: SocketClient.cpp,v 1.3 2009/02/09 18:20:13 avalassi Exp $

// Include files
#include "CoralSockets/SocketClient.h"


#include "SocketRequestHandler.h"
#include "TcpSocket.h"

// Namespace
using namespace coral::CoralSockets;

#include <sys/time.h> // for gettimeof day debug

#define DEBUG( out ) do { timeval val; gettimeofday( &val, 0); std::cerr << "["<< val.tv_usec << "]" << out << std::endl; } while (0)

#ifndef DEBUG
#define DEBUG( out )
#endif
     
SocketClient::SocketClient( const std::string& host, int port )
{
  std::cout << "Create SocketClient" << std::endl;
  std::cout << "Connect to host " << host << " and port " << port << std::endl;

  PacketSocketPtr socket = PacketSocketPtr( 
      new PacketSocket( TcpSocket::connectTo( host, port ) ) );
  std::cout << "Connection established" << std::endl;

  m_handler =  new SocketRequestHandler( socket );
}

SocketClient::~SocketClient() 
{
  std::cout << "Delete SocketClient" << std::endl;
  delete m_handler;
}

coral::IRequestHandler* SocketClient::getRequestHandler()
{
  return m_handler;
}


