#ifndef CORAL_CORALSTUBS_REQUESTHANDLER_H
#define CORAL_CORALSTUBS_REQUESTHANDLER_H

#include "CoralServerBase/IRequestHandler.h"
#include "CoralServerBase/ICoralFacade.h"

namespace coral {

  class ByteBuffer;

  namespace CoralStubs {
    //forward declarations
    struct rowitermgr;
    
    class StaticBufferPool;
        
    /** @class ServerStub
    *
    *  An inheritance of the IRequestHandler used for the server side
    *
    *  @author Alexander Kalkhof
    *  @date   2009-01-28
    */
 
    class ServerStub : public IRequestHandler {
    public:
      //constructor
      ServerStub(ICoralFacade& coralFacade);
      //destructor, virtual because of virtual functions
      virtual ~ServerStub();
      
      IByteBufferIteratorPtr replyToRequest( const ByteBuffer& requestBuffer );
 
    private:
    
      ICoralFacade& m_facade;

      StaticBufferPool* m_bufferpool;
      
      rowitermgr* m_rowiterators;
                
    };
   
  
  }
  
}

#endif
