#include "RowIteratorAll.h"
#include "Exceptions.h"

#include <iostream>

namespace coral { namespace CoralStubs {     
      
RowIteratorAll::RowIteratorAll(AttributeList* rowBuffer)
  : m_obuffer( rowBuffer ) 
  , m_pos( 0 )
{
  m_data.clear();
}
      
RowIteratorAll::~RowIteratorAll()
{
//  std::cout << "deallocate RowIteratorAll" << std::endl;
}
      
bool
RowIteratorAll::next()
{
  if(m_pos < m_data.size()){
    m_pos++;
    return true;
  }
  return false;
}
    
bool
RowIteratorAll::isLast() const
{
  return m_pos == m_data.size();
}
    
const AttributeList&
RowIteratorAll::currentRow() const
{
  if((m_pos == 0))
  {
    throw ReplyIteratorException("Wrong access to RowIterator, call next() first","RowIteratorAll::currentRow");
  }
//  std::cout << "row position: " << m_pos << " memory pos: " << m_data[m_pos - 1] << std::endl;
  if( m_obuffer == NULL )
  {
    return *(m_data[m_pos - 1]);
  }
  else
  {
    *m_obuffer = *(m_data[m_pos - 1]);
    return *m_obuffer;
  }
}
      
AttributeList&
RowIteratorAll::addRow()
{
  AttributeList* attrp = new AttributeList;
  m_data.push_back(attrp);
//  std::cout << "row position: " << m_data.size() << " memory pos: " << attrp << std::endl;
  return *attrp;
}
      
} }
