#ifndef CORAL_CORALSTUBS_ROWITERATORALL_H
#define CORAL_CORALSTUBS_ROWITERATORALL_H

// Include files
#include "CoralBase/AttributeList.h"

#include "CoralServerBase/IRowIterator.h"

namespace coral {

  namespace CoralStubs {
  
    class RowIteratorAll : public IRowIterator {
    public:
    
      RowIteratorAll(AttributeList* rowBuffer = NULL);
      
      virtual ~RowIteratorAll();
      
      bool next();
    
      bool isLast() const;
    
      const AttributeList& currentRow() const;
      
      AttributeList& addRow();
      
      size_t size() { return m_data.size(); };
      
      void reset() { m_pos = 0; };
    
    private:

      AttributeList* m_obuffer;
        
      std::vector<AttributeList*> m_data;
      
      size_t m_pos;
    
    };

  
  }
  
}

#endif
