#ifndef CORAL_CORALSTUBS_ROWITERATORFETCH_H
#define CORAL_CORALSTUBS_ROWITERATORFETCH_H

// Include files
#include "CoralBase/AttributeList.h"

#include "CoralServerBase/IRequestHandler.h"

#include "CoralServerBase/IRowIterator.h"

#include "CoralServerBase/ICoralFacade.h"

#include "CppTypes.h"

namespace coral {

  namespace CoralStubs {
  
    class RowIteratorFetch : public IRowIterator {
    public:
      //pass by a predefined rowbuffer to replace the internal one
      RowIteratorFetch(IRequestHandler& requestHandler, uint32_t cursorID, size_t maxrows, AttributeList* rowBuffer);
    
      virtual ~RowIteratorFetch();
      
      bool next();
    
      const AttributeList& currentRow() const;

    private:
    
      AttributeList* m_obuffer;
      //reference to an IRequestHandler instance
      IRequestHandler& m_requestHandler;
      
      uint32_t m_cursor;
      
      size_t m_maxrows;
      
      AttributeList* m_attrlist;
      
    };
    
  }     
}
    
#endif
