// $Id: SingleReplyIterator.cpp,v 1.4 2009/02/09 14:15:32 kalkhof Exp $

// Include files
#include "CoralBase/Exception.h"

// Local include files
#include "SingleReplyIterator.h"

// Namespace
namespace coral { namespace CoralStubs {

//-----------------------------------------------------------------------------

SingleReplyIterator::SingleReplyIterator( coral::ByteBuffer& buffer, StaticBufferPool& pool )
  : m_next( 0 )
  , m_buffer( buffer )
  , m_pool( pool ) 
{
}

//-----------------------------------------------------------------------------

SingleReplyIterator::~SingleReplyIterator()
{
  m_pool.releaseBuffer( m_buffer );
}

//-----------------------------------------------------------------------------

bool SingleReplyIterator::next()
{
  m_next++;
  if ( m_next == 1 ) return true;
  else return false;
}

//-----------------------------------------------------------------------------

bool SingleReplyIterator::isLast() const
{
  if ( m_next == 0 ) 
    throw Exception( "Iterator is still before the start", 
                     "SingleReplyIterator::isLast",
                     "coral::CoralServerBase" );
  else if ( m_next == 1 ) 
    return true;
  else 
    throw Exception( "Iterator is already past the end", 
                     "SingleReplyIterator::isLast",
                     "coral::CoralServerBase" );
}

//-----------------------------------------------------------------------------

const coral::ByteBuffer& SingleReplyIterator::currentBuffer() const
{
  if ( m_next == 0 ) 
    throw Exception( "Iterator is still before the start", 
                     "SingleReplyIterator::currentReply",
                     "coral::CoralServerBase" );
  else if ( m_next == 1 ) 
    return m_buffer;
  else 
    throw Exception( "Iterator is already past the end", 
                     "SingleReplyIterator::currentReply",
                     "coral::CoralServerBase" );
}

//-----------------------------------------------------------------------------
} }

