#ifndef CORAL_CORALSTUBS_TESTS_BYTEBUFFERPOOLSIMPLE_H
#define CORAL_CORALSTUBS_TESTS_BYTEBUFFERPOOLSIMPLE_H

#include "CoralServerBase/ByteBuffer.h"

#include "CppMutex.h"

namespace coral {

  namespace CoralStubs {
  
    /** @class StaticBufferPool
    *
    *  A static pool of 20 ByteBuffers
    *
    *  @author Alexander Kalkhof
    *  @date   2009-02-09
    */
  
    class StaticBufferPool {
    public:
  
      StaticBufferPool();
    
      ~StaticBufferPool();
  
      ByteBuffer& allocateBuffer();
    
      void releaseBuffer( const ByteBuffer& buffer );
    
      bool isEmpty();

    private:
  
      ByteBuffer* s_buffer[21];
    
      bool s_allocated[21];
      
      pmutex_t* m_mutex;
    
    };

  }    

}

#endif



