// Include files
#include <sstream>
#include <iostream>
#include "CoralBase/Exception.h"
#include "CoralBase/AttributeList.h"
#include "CoralBase/Attribute.h"

#include "CoralServerBase/ByteBuffer.h"
#include "CoralServerBase/IRequestHandler.h"
#include "CoralServerBase/CALPacketHeader.h"
#include "CoralServerBase/CALOpcode.h"
#include "CoralServerBase/QueryDefinition.h"


#include "CoralStubs/ServerStub.h"
#include "CoralStubs/ClientStub.h"
#include "../../src/DummyFacade.h"
#include "CoralServerBase/ICoralFacade.h"

#include "RelationalAccess/TableDescription.h"

#include "../../src/RowIteratorAll.h"

  int main( int /*argc*/, char* /*argv[]*/ ){
    coral::CoralStubs::DummyFacade df;
    //create a request handler
    coral::CoralStubs::ServerStub sstub(df);
    //create a coral facade    
    coral::CoralStubs::ClientStub cstub(sstub);
    
    
    coral::Token session = 0;
 //   try{
 
    bool fromProxy;
    
      session = cstub.connect("http://hello_world", coral::ReadOnly, fromProxy);
  //  }
 //   catch(...)
 //   {
 //     return 1;
  //  }  
    cstub.startTransaction(session, true);
    
    coral::QueryDefinition qd;
    
    qd.addToOrderList( "Col01" );
    
    qd.addToTableList( "Table01", "T1" );
    
    qd.limitReturnedRows( 5, 32342 );

    
    coral::AttributeList al01;
    coral::AttributeList al02;
    
    al01.extend("Column01", typeid(std::string) );
    al01.extend("Column02", typeid(int) );

    al01[0].data<std::string>() = "hello world";
    al01[1].data<int>() = -45;
    
    coral::IRowIteratorPtr rowa = cstub.fetchRows( session, qd, &al01, 10, true );
    
    coral::IRowIterator* ia = rowa.get();
    while(ia->next()){
      const coral::AttributeList& alh = ia->currentRow();
      
      if(&alh != &al01){
        std::cout << "AttributeList missmatch !!" << std::endl;
      }

      alh.toOutputStream(std::cout) << std::endl;
    }
    
    
    al02.extend("Column03", typeid(float) );
    
    al02[0].data<float>() = 0.3423;
    
    coral::IRowIteratorPtr rowi = cstub.fetchAllRows( session, qd, &al02 );

    coral::IRowIterator* ii = rowi.get();
        
    size_t i = 0;
    while(ii->next()){
      i++;
      const coral::AttributeList& alh = ii->currentRow();
      
      if(&alh != &al02){
        std::cout << "AttributeList missmatch !!" << std::endl;
      }else{
        al02.toOutputStream(std::cout) << std::endl;
      }

      alh.toOutputStream(std::cout) << std::endl;
    }
    
    rowi = cstub.fetchAllRows( session, qd, NULL );
    
    ii = rowi.get();
    while(ii->next()){
      i++;
      const coral::AttributeList& alh = ii->currentRow();
      
      if(&alh != &al02){
        std::cout << "AttributeList missmatch !!" << std::endl;
      }else{
        al02.toOutputStream(std::cout) << std::endl;
      }

      alh.toOutputStream(std::cout) << std::endl;
    }

        
    const std::set<std::string> myset = cstub.listTables(session, "MySchema");
    std::set<std::string>::const_iterator j;
    for(j = myset.begin(); j != myset.end(); j++ )
    {
      std::cout << "listTables : " << *j << std::endl;
    }
    
    const std::vector<std::string> sp = cstub.sessionProperties( session );
    
    const coral::TableDescription tdesc = cstub.tableDescription(session, "MySchema", "MyGreatTable" );
    
    const coral::TableDescriptionMap tdescm = cstub.tableDescriptionMap(session, "MySchema" );
    
    cstub.commitTransaction(session);
    
    cstub.releaseSession(session);
       
//    coral::ByteBuffer requestBuffer(30000);

    
        
//    coral::CALPacketHeader header_request(coral::CALOpcodes::ConnectRO, false, 0);
//    memcpy(requestBuffer.data(), header_request.data(), coral::CALPACKET_HEADER_SIZE);

//    coral::ByteBuffer& replyBuffer = replyBufferPool.allocateBuffer();
  
//    coral::IReplyIteratorPtr reply = rh.replyToRequest( requestBuffer, replyBufferPool );
    
      session = cstub.connect("http://hello_world", coral::ReadOnly, fromProxy);
    
    cstub.startTransaction(session, false);
    
    cstub.commitTransaction(session);

    cstub.releaseSession(session);
      
  }
