// Include files
#include <sstream>
#include "CoralBase/Exception.h"
#include "CoralServerBase/ByteBuffer.h"
#include "../../src/StreamBuffer.h"

  int main( int /*argc*/, char* /*argv[]*/ ){

    coral::ByteBuffer bytebuffer(30000);

    coral::CoralStubs::WStreamBuffer streamw(bytebuffer);
    coral::CoralStubs::RStreamBuffer streamr(bytebuffer, 0);

    unsigned char c1 = 'F';
        
    streamw.write((unsigned char)'L');
    streamw.write(c1);

    unsigned char c2 = 'H';
    
    streamr.read(c2);
    streamr.read(c2);
    
    streamr.print();
    
    std::string s1("Hello world!");
    
    streamw.write(s1);

    s1 = "CoralServer";
    
    streamw.write(s1);
    
    std::string s2;
    
    streamr.read(s2);
   
    streamr.read(s2);

    streamr.print();
    
    if(c1 != c2) throw;
    if(s1.compare(s2)) throw;
        
    return 1;
  }
