#include "ConnectionPoolTimer.h"
#include "ConnectionPool.h"
#include "CoralCommon/Utilities.h"

/// constructor
coral::ConnectionService::ConnectionPoolTimer::ConnectionPoolTimer():m_pool(0), m_cleanUpPeriod(0){}

/// constructor
coral::ConnectionService::ConnectionPoolTimer::ConnectionPoolTimer( ConnectionPool& pool, const int& cleanUpPeriod ):
  m_pool(&pool),m_cleanUpPeriod(&cleanUpPeriod){}

/// destructor
coral::ConnectionService::ConnectionPoolTimer::~ConnectionPoolTimer(){
}



// functor procedure
void coral::ConnectionService::ConnectionPoolTimer::operator()(){
  if(m_pool)
  {
    while( true ){
      m_pool->cleanUpTimedOutConnections();
      int waitSec=5;
      if(m_cleanUpPeriod){
        waitSec = *m_cleanUpPeriod;
      }
      coral::sleepSeconds(waitSec);
      if( m_pool->isFinalized() ) break;
    }
    
  }
}

