#include "RelationalAccess/IDatabaseServiceDescription.h"
#include "ServiceSpecificConfiguration.h"
#include <sstream>

void
coral::ConnectionService::ServiceSpecificConfiguration::overWriteIfExistsSpecific(int& value, const std::string& paramName) const {
  std::map<std::string,std::string>::const_iterator iPar = m_serviceParams.find(paramName);
  if(iPar!=m_serviceParams.end()){
    std::istringstream ss(iPar->second);
    ss >> value;
  }
}

int
coral::ConnectionService::ServiceSpecificConfiguration::connectionRetrialPeriod() const {
  int val = 0;
  if(m_configuration){
    val = m_configuration->connectionRetrialPeriod();
    this->overWriteIfExistsSpecific(val,coral::IDatabaseServiceDescription::connectionRetrialPeriodParam());
  }
  return val;
}

int
coral::ConnectionService::ServiceSpecificConfiguration::connectionRetrialTimeOut() const {
  int val = 0;
  if(m_configuration){
    val = m_configuration->connectionRetrialTimeOut();
    this->overWriteIfExistsSpecific(val,coral::IDatabaseServiceDescription::connectionRetrialTimeOutParam()); 
  }
  return val;
}

int
coral::ConnectionService::ServiceSpecificConfiguration::connectionTimeOut() const{
  int val = 0;
  if(m_configuration){
    val = m_configuration->connectionTimeOut();
    // time-out=0 cannot be overwritten
    if(val) this->overWriteIfExistsSpecific(val,coral::IDatabaseServiceDescription::connectionTimeOutParam()); 
  }
  return val;  
}

