/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "Cursor.h"

START_CORALACCESS_NAMESPACE

using CORALMESSAGING_NAMESPACE_NAME::CAL::ExecuteQueryReply;

Cursor::Cursor(const Pointer<IMessage>::Shared& reply, coral::AttributeList& externalBuffer)
	: _buffer(externalBuffer),
      _reply(reply)
{
	const ExecuteQueryReply& r = dynamic_cast<const ExecuteQueryReply&>(*_reply);
	_itr = r.rows().begin();
	_end = r.rows().end();
}

bool Cursor::next()
{
	if (_itr != _end) {
		_buffer = _itr->attributeList();
		++_itr;
		return true;
	}

	return false;
}

const coral::AttributeList& Cursor::currentRow() const
{
	return _buffer;
}

void Cursor::close()
{
	_itr = _end;
}

END_CORALACCESS_NAMESPACE

