/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#ifndef CORALACCESS_CURSOR_H
#define CORALACCESS_CURSOR_H

#include <vector>

#include "CoralMessaging/CAL/CALMessages.h"
#include "CoralMessaging/CAL/MsgObj/AttributeListRepresentation.h"
#include "CoralMessaging/Insulation/Attribute.h"
#include "CoralBase/AttributeList.h"
#include "RelationalAccess/ICursor.h"

#include "Pointers.h"

START_CORALACCESS_NAMESPACE

using CORALMESSAGING_NAMESPACE_NAME::IMessage;

class Cursor : virtual public coral::ICursor
{
public:
	Cursor(const Pointer<IMessage>::Shared& reply, coral::AttributeList& externalBuffer);

	virtual bool next();

	virtual const AttributeList& currentRow() const;

	virtual void close();

private:
	typedef std::vector<CORALMESSAGING_NAMESPACE_NAME::CAL::MsgObj::AttributeListRepresentation> _ResultSetType;
	_ResultSetType::const_iterator _itr;
	_ResultSetType::const_iterator _end;
	coral::AttributeList& _buffer;
	Pointer<IMessage>::Shared _reply;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_CURSOR_H
