/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_DATAEDITOR_H
#define CORALACCESS_DATAEDITOR_H

#include "base.h"

#include "RelationalAccess/ITableDataEditor.h"
#include "RelationalAccess/ITableDescription.h"

START_CORALACCESS_NAMESPACE

class DataEditor : virtual public coral::ITableDataEditor
{
public:
	DataEditor();

	virtual ~DataEditor();

	// From coral::ITableDataEditor
	void rowBuffer( coral::AttributeList& buffer );

	void insertRow( const coral::AttributeList& dataBuffer );

	coral::IOperationWithQuery* insertWithQuery();

	coral::IBulkOperation* bulkInsert(const coral::AttributeList& dataBuffer, int rowCacheSize);

	coral::IBulkOperationWithQuery* bulkInsertWithQuery(int dataCacheSize);

	long updateRows(const std::string& setClause, const std::string& condition, const coral::AttributeList& inputData);

	coral::IBulkOperation* bulkUpdateRows(const std::string& setClause, const std::string& condition, const coral::AttributeList& inputData, int dataCacheSize);

	long deleteRows(const std::string& condition, const coral::AttributeList& conditionData);

	coral::IBulkOperation* bulkDeleteRows(const std::string& condition, const coral::AttributeList& conditionData, int dataCacheSize);
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_DATAEDITOR_H
