/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_ICONNECTIONSTUB_H
#define CORALACCESS_ICONNECTIONSTUB_H

#include "base.h"

#include "CoralMessaging/Pointers.h"
#include "CoralMessaging/IMessage.h"

START_CORALACCESS_NAMESPACE

using coral::CoralMessaging::IMessage;

typedef coral::CoralMessaging::Pointer<IMessage>::Shared IMessagePtr;

class IConnectionStub {
public:
    virtual ~IConnectionStub() {};

    virtual uint32_t send(const IMessage& msg) = 0;

    virtual IMessagePtr recv(uint32_t requestID, uint8_t opcode) = 0;

    virtual IMessagePtr sendRecv(const IMessage& msg, uint8_t opcode) = 0;
    
    virtual bool connected() const = 0;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_ICONNECTIONSTUB_H
