/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_ICONNECTIONSTUBFACTORY_H
#define CORALACCESS_ICONNECTIONSTUBFACTORY_H

#include "base.h"

#include <string>

#include "CoralProtocol/arch.h"

START_CORALACCESS_NAMESPACE

class IConnectionStub;

class IConnectionStubFactory {
public:
    virtual ~IConnectionStubFactory() {};

    virtual IConnectionStub* create(const std::string& domainName, const std::string& host, uint32_t port, const uint32_t cid) const = 0;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_ICONNECTIONSTUBFACTORY_H
