/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#ifndef CORALACCESS_MONITORCONTROLLER_H
#define CORALACCESS_MONITORCONTROLLER_H

#include "base.h"

#include "RelationalAccess/IMonitoring.h"

START_CORALACCESS_NAMESPACE

class MonitorController : virtual public coral::IMonitoring
{
public:
	// from coral::IMonitoring
    virtual void start( monitor::Level level = monitor::Default );

    virtual void stop();
  
    virtual void reportToOutputStream( std::ostream& os ) const;

    virtual void report() const;
    
    virtual bool isActive() const;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_MONITORCONTROLLER_H
