/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "CoralMessaging/CAL/CALMessages.h"

#include "NotImplemented.h"
#include "Connection.h"
#include "IConnectionStub.h"
#include "Session.h"
#include "SchemaEditor.h"

START_CORALACCESS_NAMESPACE

SchemaEditor::SchemaEditor(Session& session)
	: _session(session)
{
	// EMPTY
}

SchemaEditor::~SchemaEditor()
{
	// EMPTY
}

std::set<std::string> SchemaEditor::listTables() const
{
	using coral::CoralMessaging::CAL::ListTables;
	using coral::CoralMessaging::CAL::ListTablesReply;
	using coral::CoralProtocol::Opcode;
	
	ListTables msg;
	IMessagePtr replyPtr = _session.connection().getStub().sendRecv(msg, Opcode::E_ListTablesReply);
	ListTablesReply& reply = dynamic_cast<ListTablesReply&>(*replyPtr);
	return std::set<std::string>(reply.tableList().begin(), reply.tableList().end());
}

void SchemaEditor::truncateTable(const std::string& /*tableName*/)
{
	throw NotImplemented(__FUNCTION__);
	// TODO
}

void SchemaEditor::dropTable(const std::string& /*tableName*/)
{
	throw NotImplemented(__FUNCTION__);
	// TODO
}

void SchemaEditor::createTable(const coral::ITableDescription& /* description */)
{
	throw NotImplemented(__FUNCTION__);
	// TODO
}

bool SchemaEditor::existsView(const std::string& /*viewName*/) const
{
	// TODO
	throw NotImplemented(__FUNCTION__);
	return false;
}

void SchemaEditor::dropView(const std::string& /*viewName*/)
{
	throw NotImplemented(__FUNCTION__);
	// TODO
}

std::set<std::string> SchemaEditor::listViews() const
{
	// TODO
	throw NotImplemented(__FUNCTION__);
	return std::set<std::string>();
}

IView& SchemaEditor::viewHandle(const std::string& /*viewName*/)
{
	// TODO
	throw NotImplemented(__FUNCTION__);
}

END_CORALACCESS_NAMESPACE
