/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "CoralMessaging/CAL/CALMessages.h"

#include "Session.h"
#include "ConnectionStub.h"
#include "Connection.h"
#include "SchemaLoader.h"

START_CORALACCESS_NAMESPACE

bool SchemaLoader::schemaExists(Session& session, const std::string& schemaName)
{
	coral::CoralMessaging::CAL::TableSchemaExists msg(schemaName);
	IMessagePtr reply = session.connection().getStub().sendRecv(msg, coral::CoralProtocol::Opcode::E_OK);
	return true;
};

END_CORALACCESS_NAMESPACE
