/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "DomainProperties.h"
#include "SessionProperties.h"

START_CORALACCESS_NAMESPACE

SessionProperties::SessionProperties(IConnectionStub& stub, const DomainProperties& domainProperties, const std::string& schemaName)
	: _stub(stub),
	  _domainProperties( domainProperties ),
	  _schemaName(schemaName)
{
	// EMPTY
}

SessionProperties::~SessionProperties() 
{
	// EMPTY
}

IConnectionStub& SessionProperties::getStub()
{
	return _stub;
}

const std::string& SessionProperties::schemaName() const
{
	return _schemaName;
}

const DomainProperties& SessionProperties::domainProperties() const
{
	return _domainProperties;
}

END_CORALACCESS_NAMESPACE
