/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_SESSIONPROPERTIES_H
#define CORALACCESS_SESSIONPROPERTIES_H

#include <string>

#include "DomainProperties.h"

START_CORALACCESS_NAMESPACE

class IConnectionStub;

class SessionProperties
{
public:
	SessionProperties(IConnectionStub& stub, const DomainProperties& domainProperties, const std::string& schemaName);
	virtual ~SessionProperties();
	
    IConnectionStub& getStub();
    const DomainProperties& domainProperties() const;
    const std::string& schemaName() const;
    
private:
	IConnectionStub& _stub;
	const DomainProperties& _domainProperties;
	const std::string _schemaName;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_SESSIONPROPERTIES_H
