/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "Session.h"
#include "Table.h"

START_CORALACCESS_NAMESPACE

Table::Table(const std::string& schemaName, const std::string& tableName, Session& session)
    : _session(session),
      _tableDesc(tableName),
      _tableSchemaEditor(schemaName, tableName, _tableDesc, session, true),
      _tablePrivilegeManager(session, tableName),
      _schemaName(schemaName)
{
	// EMPTY
}

Table::~Table()
{
	// EMPTY
}

const ITableDescription& Table::description() const
{
	return _tableDesc;
}

ITableSchemaEditor& Table::schemaEditor()
{
	return _tableSchemaEditor;
}

ITableDataEditor& Table::dataEditor()
{
	return _dataEditor;
}

ITablePrivilegeManager& Table::privilegeManager()
{
	return _tablePrivilegeManager;
}

IQuery* Table::newQuery() const
{
	return new SingleTableQuery(_session, _schemaName, _tableDesc.name());
}

END_CORALACCESS_NAMESPACE
