/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TABLE_H
#define CORALACCESS_TABLE_H

#include "base.h"

#include <string>

#include "RelationalAccess/ITable.h"
#include "RelationalAccess/TableDescription.h"

#include "DataEditor.h"
#include "TableSchemaEditor.h"
#include "PrivilegeManager.h"
#include "Query.h"

START_CORALACCESS_NAMESPACE

class Session;

class Table : virtual public coral::ITable
{
public:
	Table(const std::string& schemaName, const std::string& tableName, Session& session);

	virtual ~Table();

	virtual const ITableDescription& description() const;

	virtual ITableSchemaEditor& schemaEditor();

	virtual ITableDataEditor& dataEditor();

	virtual ITablePrivilegeManager& privilegeManager();

	virtual IQuery* newQuery() const;

private:
	Session& _session;
	coral::TableDescription _tableDesc;
	TableSchemaEditor _tableSchemaEditor;
	PrivilegeManager _tablePrivilegeManager;
	DataEditor _dataEditor;
	const std::string _schemaName;
};

END_CORALACCESS_NAMESPACE

#endif // CORALACCESS_TABLE_H
