/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TABLESCHEMALOADER_H
#define CORALACCESS_TABLESCHEMALOADER_H

#include <string>

#include "RelationalAccess/TableDescription.h"
#include "base.h"

START_CORALACCESS_NAMESPACE

class Session;

class TableSchemaLoader
{
public:
	/// Constructor
	TableSchemaLoader(Session& s, const std::string& schemaName);
	/// Destructor
	virtual ~TableSchemaLoader();

	void refreshTableDescription(coral::TableDescription& description);

private:
	Session& _session;
	const std::string& _schemaName;
};

END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_TABLESCHEMALOADER_H
