/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "CoralMessaging/Tcp/TcpSocketFactory.h"

#include "ConnectionStub.h"
#include "TcpConnectionStubFactory.h"

START_CORALACCESS_NAMESPACE;

IConnectionStub* TcpConnectionStubFactory::create(const std::string& domainName, const std::string& host, uint32_t port, const uint32_t cid) const
{
	typedef coral::CoralMessaging::Pointer<coral::CoralMessaging::ICoralIOHandler>::Shared HandterPtrType;
	HandterPtrType h(coral::CoralMessaging::Tcp::TcpSocketFactory::CreateConnectingSocket(port, host));
	return new ConnectionStub(domainName, cid, h);
}

END_CORALACCESS_NAMESPACE
