/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TYPECONVERTER_H
#define CORALACCESS_TYPECONVERTER_H

#include "base.h"

#include <string>
#include <set>
#include <boost/noncopyable.hpp>

#include "RelationalAccess/ITypeConverter.h"

START_CORALACCESS_NAMESPACE

class TypeConverter : public coral::ITypeConverter, public boost::noncopyable
{
public:
	virtual ~TypeConverter();
	// From ITypeConverter
	virtual std::set<std::string> supportedSqlTypes() const;

	virtual std::set<std::string> supportedCppTypes() const;

	virtual std::string defaultCppTypeForSqlType(const std::string& sqlType) const;

	virtual std::string cppTypeForSqlType(const std::string& sqlType) const;

	virtual void setCppTypeForSqlType(const std::string& cppType, const std::string& sqlType);

	virtual std::string defaultSqlTypeForCppType(const std::string& cppType) const;

	virtual std::string sqlTypeForCppType(const std::string& cppType) const;

	virtual void setSqlTypeForCppType(const std::string& sqlType, const std::string& cppType);
};
    
END_CORALACCESS_NAMESPACE

#endif // #ifndef CORALACCESS_TYPECONVERTER_H
