
#include "CoralMessaging/CAL/CALMessages.h"
#include "CoralMessaging/CoralSocket.h"
#include "CoralMessaging/Insulation/TimeStamp.h"
#include "UnitTests/gnuplot.h"

#include "../../src/ConnectionStub.h"

#include <vector>
#include <string>
#include <map>
#if 0
typedef std::map<unsigned int, unsigned int> histogram_t;

void wait_for_key ()
{
#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(__TOS_WIN__)  // every keypress registered, also arrow keys
    std::cout << std::endl << "Press any key to continue..." << std::endl;

    FlushConsoleInputBuffer(GetStdHandle(STD_INPUT_HANDLE));
    _getch();
#elif defined(unix) || defined(__unix) || defined(__unix__) || defined(__APPLE__)
    std::cout << std::endl << "Press ENTER to continue..." << std::endl;

    std::cin.clear();
    std::cin.ignore(std::cin.rdbuf()->in_avail());
    std::cin.get();
#endif
    return;
}

int test_ping()
{
	histogram_t hist;
    std::vector<int> x, y;
    Gnuplot g1("PING test");

	coral::CoralMessaging::theLogger().setLogOff();
	coral::CoralAccess::ConnectionStub stub("127.0.0.1", 8080);
    coral::CoralMessaging::CAL::MsgObj::Connection connection(true, "/tests/db_ora/admin", "", "");
    coral::CoralMessaging::CAL::MsgObj::MonitoringInformation monitor(getpid(), "testmachine");

    if (!stub.sendRecv(coral::CoralMessaging::CAL::Connect(connection, monitor), coral::CoralProtocol::Opcode::E_OK).first) goto FAIL;

    for (int i = 0; i < 350; ++i)
    {
    	long start = coral::TimeStamp::now().nanosecond();

    	for (int j = 0; j < 20; ++j)
    	{
    		if (!stub.sendRecv(coral::CoralMessaging::CAL::Ping0(), coral::CoralProtocol::Opcode::E_Ping0).first) goto FAIL;
    	}

    	long duration = coral::TimeStamp::now().nanosecond() - start;
    	// TODO: why can we see negative values???
    	if (duration > 0) ++hist[duration / 20 / 20];

    	std::cout << i * 20 << "... " << std::flush;
    }

    for (histogram_t::const_iterator i = hist.begin(); i != hist.end(); ++i)  // fill double arrays x, y, z
    {
    	x.push_back(i->first);             // x[i] = i
        y.push_back(i->second); // y[i] = i^2
    }

    g1.set_xrange(*std::min_element(x.begin(), x.end()), *std::max_element(x.begin(), x.end()));
    g1.set_yrange(*std::min_element(y.begin(), y.end()), *std::max_element(y.begin(), y.end()));
    g1.set_style("steps").plot_xy(x, y,"PING turnaround distribution");
    wait_for_key();
    return 1;

FAIL:
	std::cerr << "Test failed" << std::endl;
	return 0;
}
#endif

int main(int, char **)
{
	// return test_ping();
}
