/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "CoralMessaging/CAL/CALMessages.h"
#include "CoralMessaging/Stream/DataStringStream.h"

#include "ConnectionStubTest.h"

START_CORALACCESS_NAMESPACE

using namespace coral::CoralMessaging;
using namespace coral::CoralAccess;

void ConnectionStubTest::test()
{
	uint32_t clientID = 0;
	Pointer<ICoralIOHandler>::Shared stream(new Stream::DataStringStream);
	ConnectionStub cs("TestDomain", clientID, stream);
	CPPUNIT_ASSERT(!stream->isClosed());
	CPPUNIT_ASSERT(cs.connected());
	CAL::Ping0 msg1;
	// Check message with the first request ID
	CPPUNIT_ASSERT_EQUAL(uint32_t(0), cs.send(msg1));
	IMessagePtr reply1(cs.recv(0, msg1.opcode()));
	CPPUNIT_ASSERT(reply1.get());
	CPPUNIT_ASSERT_EQUAL(msg1.opcode(), reply1->opcode());
	// Check message with the second request ID
	CPPUNIT_ASSERT_EQUAL(uint32_t(1), cs.send(msg1));
	IMessagePtr reply2(cs.recv(1, msg1.opcode()));
	CPPUNIT_ASSERT(reply2.get());
	CPPUNIT_ASSERT_EQUAL(msg1.opcode(), reply2->opcode());
	IMessagePtr reply3(cs.sendRecv(msg1, msg1.opcode()));
	CPPUNIT_ASSERT(reply3.get());
	CPPUNIT_ASSERT_EQUAL(msg1.opcode(), reply3->opcode());
}

END_CORALACCESS_NAMESPACE
