/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_CONNECTIONTEST_H_
#define CORALACCESS_TESTS_CONNECTIONTEST_H_

#include "../../src/IConnectionStubFactory.h"
#include "../../src/IConnectionStub.h"

#include "TestBase.h"

START_CORALACCESS_NAMESPACE

class Connection;

#define TEST_NAMES (testSuccessfullConnection)

class ConnectionTest: public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (ConnectionTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	void _testSuccessfullConnection(Connection& connection);
};

#undef TEST_NAMES

class ConnectionTestConnectionFactory : public IConnectionStubFactory
{
public:
	IConnectionStub* create(const std::string& domainName, const std::string& host, uint32_t port, const uint32_t cid) const;
};

class ConnectionTestConnectionStub : public IConnectionStub
{
public:
    virtual uint32_t send(const IMessage&) {return 0;};

    virtual IMessagePtr recv(uint32_t, uint8_t) {return IMessagePtr();};

    virtual IMessagePtr sendRecv(const IMessage& msg, uint8_t opcode);

    virtual bool connected() const {return true;}

private:
	static int _msgExchange;
};

END_CORALACCESS_NAMESPACE

#endif /*CORALACCESS_TESTS_CONNECTIONTEST_H_*/
