/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include <boost/assign/std/vector.hpp>

#include "CoralMessaging/Insulation/AttributeList.h"
#include "CoralMessaging/CAL/CALMessages.h"

#include "../../src/Cursor.h"
#include "CursorTest.h"

#include <vector>

START_CORALACCESS_NAMESPACE

using CORALMESSAGING_NAMESPACE_NAME::CAL::MsgObj::AttributeListRepresentation;
using CORALMESSAGING_NAMESPACE_NAME::CAL::ExecuteQueryReply;
using CORALMESSAGING_NAMESPACE_NAME::IMessage;

void CursorTest::test()
{
	AttributeList al;
	al.extend("attr", typeid(bool));
	std::vector<AttributeListRepresentation> v1;
	boost::assign::push_back(v1)(AttributeListRepresentation(al))(AttributeListRepresentation(al))(AttributeListRepresentation(al));
	const_cast<AttributeList&>(v1.back().attributeList())[0].data<bool>() = true;
	Pointer<IMessage>::Shared msg(dynamic_cast<IMessage*>(new ExecuteQueryReply(v1)));
	AttributeList extbuf;
	Cursor c(msg, extbuf);

	for (size_t i = 0; i < v1.size(); ++i) {
		CPPUNIT_ASSERT(c.next());
		CPPUNIT_ASSERT_EQUAL(v1[i].attributeList(), c.currentRow());
		CPPUNIT_ASSERT_EQUAL(v1[i].attributeList(), extbuf);
	}

	CPPUNIT_ASSERT(!c.next());
}

END_CORALACCESS_NAMESPACE
