/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_LOCALSESSION_H_
#define CORALACCESS_TESTS_LOCALSESSION_H_

#include "../../src/Domain.h"
#include "../../src/Connection.h"
#include "../../src/Session.h"

#include "DomainHandle.h"
#include "TestBase.h"

START_CORALACCESS_NAMESPACE

template<class ConnectionFactory>
class LocalSession
{
public:
	LocalSession()
		: _connection(dynamic_cast<Connection*>(_dh.get().newConnection(TestData::CoralServerUrl)))
    {
		_connection->resetFactory<ConnectionFactory>();
    	_connection->connect();
    	_session.reset(dynamic_cast<Session*>(_connection->newSession(TestData::ExistingDbUri, coral::ReadOnly)));
    }

	Session& session() {return *_session;}

private:
	DomainHandle _dh;
	Pointer<Connection>::Scoped _connection;
	Pointer<Session>::Scoped _session;
};

END_CORALACCESS_NAMESPACE

#endif /*CORALACCESS_TESTS_LOCALSESSION_H_*/
