/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "../../src/Connection.h"
#include "../../src/Session.h"

#include "OracleSessionCreator.h"

START_CORALACCESS_NAMESPACE

OracleSessionCreator::OracleSessionCreator(coral::AccessMode access)
	: _connection(dynamic_cast<Connection*>(_dh.get().newConnection(TestData::CoralServerUrl)))
{
	_connection->connect();
	_session.reset(dynamic_cast<Session*>(_connection->newSession(TestData::ExistingDbUri, access)));
	_session->startUserSession("", "");
	_session->transaction().start(access == coral::ReadOnly);
}

OracleSessionCreator::~OracleSessionCreator()
{
	_session->transaction().commit();
	_session->endUserSession();
}

Session& OracleSessionCreator::session()
{
	return *_session;
}

END_CORALACCESS_NAMESPACE
