/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_ORACLESESSIONCREATOR_H_
#define CORALACCESS_TESTS_ORACLESESSIONCREATOR_H_

#include "../../src/Domain.h"
#include "../../src/Pointers.h"

#include "DomainHandle.h"
#include "TestBase.h"

START_CORALACCESS_NAMESPACE

class Connection;
class Session;

class OracleSessionCreator {
public:
	OracleSessionCreator(coral::AccessMode access);
	virtual ~OracleSessionCreator();

	Session& session();

private:
	DomainHandle _dh;
	Pointer<Connection>::Scoped _connection;
	Pointer<Session>::Scoped _session;
};

END_CORALACCESS_NAMESPACE

#endif /* CORALACCESS_TESTS_ORACLESESSIONCREATOR_H_ */
