/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_REGRESSIONTESTCASES_H_
#define CORALACCESS_TESTS_REGRESSIONTESTCASES_H_

#include "RelationalAccess/ISessionProxy.h"
#include "RelationalAccess/TableDescription.h"
#include "CoralMessaging/Insulation/AttributeList.h"

#include "TestBase.h"

START_CORALACCESS_NAMESPACE

#define TEST_NAMES (testQueryWithString)

/**
 * List of test cases that do not fall into any unit test category. These test cases
 * were real error cases, reproduced by the individual test methods. They are now
 * covered here.
 */
class RegressionTestCases: public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (RegressionTestCases);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	template <class T>
	void _addToDesc(coral::TableDescription& desc, const std::string& name);

	template <class T>
	void _addToRow(coral::AttributeList& rowBuffer, const std::string& name);

	void _createTableWithStrings(const std::string& tableName, const int rowNum);
	void _executeQuery(const std::string& tableName, ISessionProxy& session);

};

#undef TEST_NAMES

END_CORALACCESS_NAMESPACE

#endif /*CORALACCESS_TESTS_REGRESSIONTESTCASES_H_*/
