/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_SCHEMAEDITORTEST_H_
#define CORALACCESS_TESTS_SCHEMAEDITORTEST_H_

#include <string>
#include <set>

#include "RelationalAccess/IRelationalDomain.h"

#include "../../src/IConnectionStubFactory.h"
#include "../../src/IConnectionStub.h"
#include "../../src/Session.h"

#include "TestBase.h"

START_CORALACCESS_NAMESPACE

#define TEST_NAMES (testListTablesWithoutServer)(testListTablesWithServer)

class SchemaEditorTest: public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (SchemaEditorTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

    static std::set<std::string>& TableList();

    static const std::string& SchemaName()
    {
    	static const std::string s("SchemaEditorTest");
    	return s;
    }

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	bool _withServer();
	void _setupTables(const std::string& serviceName);
};

#undef TEST_NAMES

class SchemaEditorTestConnectionFactory : public IConnectionStubFactory
{
public:
	IConnectionStub* create(const std::string& domainName, const std::string& host, uint32_t port, const uint32_t cid) const;
};

class SchemaEditorTestConnectionStub : public IConnectionStub
{
public:
    virtual uint32_t send(const IMessage&) {return 0;};

    virtual IMessagePtr recv(uint32_t, uint8_t) {return IMessagePtr();};

    virtual IMessagePtr sendRecv(const IMessage& msg, uint8_t opcode);

    virtual bool connected() const {return true;}

private:
	static int _msgExchange;
};

END_CORALACCESS_NAMESPACE

#endif /*CORALACCESS_TESTS_SCHEMAEDITORTEST_H_*/
