/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_SCHEMALOADERTEST_H_
#define CORALACCESS_TESTS_SCHEMALOADERTEST_H_

#include "../../src/IConnectionStubFactory.h"
#include "../../src/IConnectionStub.h"
#include "TestBase.h"

START_CORALACCESS_NAMESPACE

#define TEST_NAMES (testSchemaExistsWithoutServer)(testSchemaExistsWithServer)

class SchemaLoaderTest: public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (SchemaLoaderTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

    static const std::string& NotExistingSchemaName()
    {
    	static const std::string s("NotExistingSchemaName");
    	return s;
    }

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)
};

class SchemaLoaderTestConnectionFactory : public IConnectionStubFactory
{
public:
	IConnectionStub* create(const std::string& domainName, const std::string& host, uint32_t port, const uint32_t cid) const;
};

class SchemaLoaderTestConnectionStub : public IConnectionStub
{
public:
    virtual uint32_t send(const IMessage&) {return 0;};

    virtual IMessagePtr recv(uint32_t, uint8_t) {return IMessagePtr();};

    virtual IMessagePtr sendRecv(const IMessage& msg, uint8_t opcode);

    virtual bool connected() const {return true;}
};

#undef TEST_NAMES

END_CORALACCESS_NAMESPACE

#endif /*#ifndef CORALACCESS_TESTS_SCHEMALOADERTEST_H_*/
