/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALACCESS_TESTS_STRESSTEST_H_
#define CORALACCESS_TESTS_STRESSTEST_H_

#include "CoralMessaging/Pointers.h"

#include "TestBase.h"

START_CORALACCESS_NAMESPACE

class OracleSessionCreator;

#define TEST_NAMES (testQueriesWithConnectionDrop)(testManyMultipleConnections)

class StressTest : public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (StressTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void);
    void tearDown (void) {};

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	static std::string _TableName() {return "T";}

	void _launchQuery(OracleSessionCreator*);
};

#undef TEST_NAMES

END_CORALACCESS_NAMESPACE

#endif /*CORALACCESS_TESTS_STRESSTEST_H_*/
