#ifndef CORAL_BASE_EXCEPTION_H
#define CORAL_BASE_EXCEPTION_H

#include <exception>
#include <string>

namespace coral {

  /// Base exception class for the CORAL system
  class Exception : public std::exception
  {
  public:
    /// Constructor
    Exception( const std::string& message,
               const std::string& methodName,
               const std::string& moduleName );
    
    Exception() {};

    /// Destructor
    virtual ~Exception() throw() {}
    
    void setMessage(const std::string& message);

    /// The error reporting method
    virtual const char* what() const throw() { return m_message.c_str(); }

  private:
    /// The name of the module which threw the exception
    std::string m_message;
  };
}

#endif
