#include <iostream>
#include <exception>

#include "CoralBase/TimeStamp.h"
#include "CoralBase/AttributeSpecification.h"

int main( int, char** )
{
  try {
  
    // Test invariant with epoch time
    coral::TimeStamp epoch( coral::TimeStamp::Epoch );
    
    std::cout << "Nanoseconds from epoch should be 0 ns and is " << epoch.total_nanoseconds() << " ns " << std::endl;
    
    coral::TimeStamp epoch11( 1970, 1, 1, 0, 0, 0, 0x000bL );
//    seal::Time       sepoch11( 1970, 0, 1, 0, 0, 0, 11, false ); // SEAL allowed to store exactly the nanoseconds/doubtfull practice

    std::cout << "1. CORAL Nanoseconds from epoch should be 11 ns and is      " << epoch11.total_nanoseconds() << " ns " << std::endl; // The result depends on the platform precision compiled in BOOST
    std::cout << "2. CORAL frac. seconds from epoch should be 11 ns and is    " << epoch11.nanosecond()        << " ns " << std::endl; 
//    std::cout << "3. SEAL  Nanoseconds from epoch should be 11 ns and is      " << sepoch11.ns()               << " ns " << std::endl;
    
    coral::TimeStamp moment  = coral::TimeStamp::now();     
//    seal::Time       smoment( moment.year(), moment.month(), moment.day(), moment.hour(), moment.minute(), moment.second(), moment.nanosecond()*1000 );
//    seal::Time      scmoment( moment.total_nanoseconds() ); 
    
    std::cout << "CORAL ns: " <<   moment.total_nanoseconds() << std::endl;
//              << "SEAL  ns: " <<  smoment.ns()                << std::endl
//              << "CSEAL ns: " << scmoment.ns()                << std::endl;

    coral::TimeStamp thisMoment = coral::TimeStamp::now(true);
    
    std::cout << "Testing the \""
              << coral::AttributeSpecification::typeNameForType( thisMoment )
              << "\" type..." << std::endl;

    std::cout << "The moment was "
              << thisMoment.day() << "/"
              << thisMoment.month() << "/"
              << thisMoment.year() << " "
              << thisMoment.hour() << ":"
              << thisMoment.minute() << ":"
              << thisMoment.second() << "."
              << thisMoment.nanosecond() << std::endl;

    coral::TimeStamp anotherMoment( 1999, 12, 21, 12, 10, 30, 213331 );
    std::cout << "Danae was born on " << anotherMoment.toString() << std::endl;
	      
    std::cout << "Nanoseconds are " << anotherMoment.total_nanoseconds() << std::endl;
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Unknown exception ..." << std::endl;
    return 1;
  }
  std::cout << "[OVAL] : Test successful" << std::endl;
  return 0;
}
