/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALBRICKS_BOOSTTIMETRAITS_H_
#define CORALBRICKS_BOOSTTIMETRAITS_H_

/**
 * Include this file only from TimeTraits. If you include it from elsewhere,
 * you will get compilation error.
 */ 

#ifndef __TIMETRAITS_H_GUARD__
  #error File is included from elsewhere that TimeTraits.h
#endif

// Disable warnings triggered by the CppUnit headers
// See http://wiki.services.openoffice.org/wiki/Writing_warning-free_code
// See also http://www.artima.com/cppsource/codestandards.html
#if defined __GNUC__
#  pragma GCC system_header
#elif defined __SUNPRO_CC
#  pragma disable_warn
#elif defined _MSC_VER
#  pragma warning(push, 1)
#endif

#include "boost/date_time/posix_time/posix_time.hpp"
#include "boost/thread/xtime.hpp"

namespace coral {

struct TimeTraits {
	typedef boost::xtime TIME;
};

} // namespace coral

#if defined __SUNPRO_CC
#  pragma enable_warn
#elif defined _MSC_VER
#  pragma warning(pop)
#endif

#endif /*CORALBRICKS_BOOSTTIMETRAITS_H_*/
