/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALCOMMON_URIPARSERTEST_H
#define CORALCOMMON_URIPARSERTEST_H

#include <boost/tuple/tuple_comparison.hpp>

#include "UnitTests/UnitTestBase.h"

namespace coral { namespace CoralCommon {

#define TEST_NAMES (test)

#define CLASS_NAME UriParserTest

class CLASS_NAME : public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (CLASS_NAME);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {}
    void tearDown (void) {}

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	typedef boost::tuple<std::string, std::string, std::string, std::string, int, std::string> URIParserTest_Results;

	URIParserTest_Results _testParser(const std::string& uri);
};

} } // namespace coral, CoralCommon

#undef CLASS_NAME

#endif // #ifndef CORALCOMMON_URIPARSERTEST_H
