#ifndef IPROPERTYMANAGER_H_
#define IPROPERTYMANAGER_H_

#include <string>
#include "IProperty.h"

namespace coral {
/**
 * Class IPropertyManager
 * Interface for an object managing a set of properties. The object must store
 * a fixed property set, properties cannot be added/deleted by this interface.
 * The properties are identified by strings (names). 
 */
struct IPropertyManager 
{
	virtual ~IPropertyManager() {}
	/**
	 * Return the property identified by the given string or NULL if the property
	 * does not exists.
	 */
	virtual IProperty* property(const std::string&) = 0; 
};

} // namespace coral

#endif /*IPROPERTYMANAGER_H_*/
