/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALKERNEL_CONTEXTTEST_H
#define CORALKERNEL_CONTEXTTEST_H

#include "UnitTests/UnitTestBase.h"
#include "CoralKernel/ILoadableComponent.h"
#include "../../src/PluginManager.h"

namespace coral { namespace CoralKernel {

/**
 * Unit tests for PluginManager class
 */

#define TEST_NAMES (testLoadedComponentsAfterAddingNewPluginManager)

#define CLASS_NAME ContextTest

class CLASS_NAME : public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (CLASS_NAME);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {}
    void tearDown (void) {}

    static const std::set<std::string>& ComponentNameFixture();

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	/**
	 * A test plugin manager, with knownPlugin overridden to return
	 * fixtures
	 **/
	struct TestPluginManager : public IPluginManager
	{
		virtual std::set<std::string> knownPlugins() const;
		virtual ILoadableComponent* newComponent(const std::string& componentName);
	};

	struct TestLoadableComponent : public ILoadableComponent
	{
		TestLoadableComponent();
	};
};

#undef CLASS_NAME

} } // namespace coral::CoralKernel

#endif // #ifndef CORALKERNEL_CONTEXTTEST_H
