/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALKERNEL_PROPERTYMANAGERTEST_H
#define CORALKERNEL_PROPERTYMANAGERTEST_H

#include "TestBase.h"

#include "CoralKernel/Context.h"
#include "CoralKernel/IPropertyManager.h"
#include "CoralKernel/Property.h"

namespace coral { namespace CoralKernel {

/**
 * Unit tests for PluginManager class
 */
class PropertyManagerTest : public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (PropertyManagerTest);
    CPPUNIT_TEST (testDefaults);
    CPPUNIT_TEST (testPropertySetting);
    CPPUNIT_TEST (testMissingPropertySetting);
    CPPUNIT_TEST (testCallback);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void);
    void tearDown (void) {}

protected:
	void testDefaults();

	void testPropertySetting();

	void testMissingPropertySetting();

	struct TestCallback
	{
		void set (const std::string& v) {val = v;}
		std::string val;
	};

	void testCallback();

private:
	coral::IPropertyManager* pm;
};

} } // namespace coral::CoralKernel

#endif // #ifndef CORALKERNEL_PROPERTYMANAGERTEST_H
