
/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_CAL_MAPBASE_H
#define CORALMESSAGING_CAL_MAPBASE_H

#include "CoralMessaging/base.h"

#include <map>

START_CORALMESSAGING_NAMESPACE

namespace CAL {

template <typename KEY, typename VALUE>
class MapBase
{
public:
	const VALUE& operator () (const KEY& k) const
	{
		typename _MapType::const_iterator i = _map.find(k);
		DEBUG_ASSERT(i != _map.end());
		return i->second;
	}

protected:
	typedef std::map<KEY, VALUE> _MapType;
	_MapType _map;
};

} // namespace CAL

END_CORALMESSAGING_NAMESPACE

#endif /* #ifndef CORALMESSAGING_CAL_MAPBASE_H*/
