/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_CAL_MSGOBJ_IMESSAGEOBJECTIMPL_H_
#define CORALMESSAGING_CAL_MSGOBJ_IMESSAGEOBJECTIMPL_H_

#include "CoralMessaging/IMessageObject.h"

START_CORALMESSAGING_NAMESPACE

namespace CAL {

namespace MsgObj {

template <class Derived>
class IMessageObjectImpl : public IMessageObject
{
public:
	explicit IMessageObjectImpl(Derived* self)
		: _self(self)
	{}

	virtual IMessageObject* clone() const
	{
		DEBUG_ASSERT_PTR(_self);
		return new Derived(*_self);
	}

	virtual bool isEqual(const IMessageObject& x) const
	{
		return *_self == dynamic_cast<const Derived&>(x);
	}

private:

	Derived* _self;
};

} // namespace MsgObj

} // namespace CAL

END_CORALMESSAGING_NAMESPACE

#endif /* #ifndef CORALMESSAGING_CAL_MSGOBJ_IMESSAGEOBJECTIMPL_H_*/
