/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#ifndef MSGOBJ_PAR_NUM

#ifndef CORAMESSAGING_CAL_MSGOBJ_MSGOBJECTGENERATOR_H_
#define CORAMESSAGING_CAL_MSGOBJ_MSGOBJECTGENERATOR_H_

#include "CoralMessaging/Stream/DataStringStream.h"
#include "CoralMessaging/Message/ClassGenerator.h"
#include "IMessageObjectImpl.h"

START_CORALMESSAGING_NAMESPACE

namespace CAL {

namespace MsgObj {

#define MSGOBJ_MESSAGE_CLASSGENERATOR_1(CLASSNAME, TYPE1) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_2(CLASSNAME, TYPE1, TYPE2) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_3(CLASSNAME, TYPE1, TYPE2, TYPE3) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_4(CLASSNAME, TYPE1, TYPE2, TYPE3, TYPE4) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3, TYPE4> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_5(CLASSNAME, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3, TYPE4, TYPE5> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_6(CLASSNAME, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_7(CLASSNAME, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7> CLASSNAME

#define MSGOBJ_MESSAGE_CLASSGENERATOR_8(CLASSNAME, TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8) \
	typedef gen::CLASSNAME::CLASSNAME##_MSGOBJ<TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6, TYPE7, TYPE8> CLASSNAME

} // namespace MsgObj

} // namespace CAL

END_CORALMESSAGING_NAMESPACE

#endif // #ifndef CORAMESSAGING_CAL_MSGOBJ_MSGOBJECTGENERATOR_H_

#else // #ifndef MSGOBJ_PAR_NUM

#include <boost/preprocessor/arithmetic/inc.hpp>
#include <boost/preprocessor/arithmetic/dec.hpp>
#include <boost/preprocessor/cat.hpp>
#include <boost/preprocessor/control/if.hpp>
#include <boost/preprocessor/repetition/repeat.hpp>
#include <boost/preprocessor/comparison/less.hpp>

#define PAR_NUM MSGOBJ_PAR_NUM

#ifdef MSGOBJ_PAR_NAME0
  #define PAR_NAME0 MSGOBJ_PAR_NAME0
#endif

#ifdef MSGOBJ_PAR_NAME1
  #define PAR_NAME1 MSGOBJ_PAR_NAME1
#endif

#ifdef MSGOBJ_PAR_NAME2
  #define PAR_NAME2 MSGOBJ_PAR_NAME2
#endif

#ifdef MSGOBJ_PAR_NAME3
  #define PAR_NAME3 MSGOBJ_PAR_NAME3
#endif

#ifdef MSGOBJ_PAR_NAME4
  #define PAR_NAME4 MSGOBJ_PAR_NAME4
#endif

#ifdef MSGOBJ_PAR_NAME5
  #define PAR_NAME5 MSGOBJ_PAR_NAME5
#endif

#ifdef MSGOBJ_PAR_NAME6
  #define PAR_NAME6 MSGOBJ_PAR_NAME6
#endif

#ifdef MSGOBJ_PAR_NAME7
  #define PAR_NAME7 MSGOBJ_PAR_NAME7
#endif

#ifdef MSGOBJ_PAR_NAME8
  #define PAR_NAME8 MSGOBJ_PAR_NAME8
#endif

#define CLASSNAME MSGOBJ_CLASSNAME
#define CLASSNAME_STR MSGOBJ_CLASSNAME_STR
#define BASECLASS MSGOBJ_CLASSNAME < BOOST_PP_ENUM_PARAMS(MSGOBJ_PAR_NUM, T) >
#define MSGOBJ_CLASSNAME_GEN BOOST_PP_CAT(MSGOBJ_CLASSNAME, _MSGOBJ)
#define IMSGOBJ_BASE_CLASS IMessageObjectImpl<MSGOBJ_CLASSNAME_GEN<BOOST_PP_ENUM_PARAMS(MSGOBJ_PAR_NUM, T)> >

#include <boost/call_traits.hpp>
#include "CoralMessaging/Message/ClassGenerator.h"

namespace gen { namespace MSGOBJ_CLASSNAME {

#define TEMPLATE_EXPR template<BOOST_PP_ENUM_PARAMS(MSGOBJ_PAR_NUM, class T)>

TEMPLATE_EXPR class MSGOBJ_CLASSNAME_GEN : public BASECLASS, public IMSGOBJ_BASE_CLASS
{
public:
	#define GENERATOR_PARAM(z, n, unused) typename boost::call_traits<T##n>::param_type par##n = T##n()
	#define GENERATOR_BASE_INIT(z, n, unused) par##n

	explicit MSGOBJ_CLASSNAME_GEN(BOOST_PP_ENUM(MSGOBJ_PAR_NUM, GENERATOR_PARAM, @), coral::CoralProtocol::t_endianness e = coral::CoralProtocol::_system_endian)
	    : BASECLASS(BOOST_PP_ENUM(MSGOBJ_PAR_NUM, GENERATOR_BASE_INIT, @), e),
	      IMSGOBJ_BASE_CLASS(this)
	{
		// EMPTY
	}

	#undef 	GENERATOR_BASE_INIT
	#undef 	GENERATOR_PARAM

	MSGOBJ_CLASSNAME_GEN(const MSGOBJ_CLASSNAME_GEN& x)
		: BASECLASS(x),
		  IMSGOBJ_BASE_CLASS(this)
	{}

	MSGOBJ_CLASSNAME_GEN& operator = (const MSGOBJ_CLASSNAME_GEN& x)
	{
		BASECLASS::operator = (x);
		return *this;
	}

	// From IMessageObject
	virtual bool decode(const std::string& raw)
	{
		Stream::DataStringStream str(raw);
		return this->template read(&str);
	}

	virtual Pointer<std::string>::Shared encode() const
	{
		Stream::DataStringStream str;
		this->template write(&str);
		DEBUG_ASSERT(!str.fail());
		return Pointer<std::string>::Shared(new std::string(str.str().str()));
	}

	virtual bool operator < (const IMessageObject& x) const
	{
		const MSGOBJ_CLASSNAME_GEN& casted = dynamic_cast<const MSGOBJ_CLASSNAME_GEN&>(x);
		#define CODE_GEN(z, n, size) this->MSGOBJ_PAR_NAME##n() < casted.MSGOBJ_PAR_NAME##n() BOOST_PP_IF(BOOST_PP_LESS(n, size), ||, )
		return BOOST_PP_REPEAT(MSGOBJ_PAR_NUM, CODE_GEN, BOOST_PP_DEC(MSGOBJ_PAR_NUM));
		#undef CODE_GEN
	}
};

}} // namespace gen

#ifdef MSGOBJ_PAR_NAME0
#  undef MSGOBJ_PAR_NAME0
#endif

#ifdef MSGOBJ_PAR_NAME1
#  undef MSGOBJ_PAR_NAME1
#endif

#ifdef MSGOBJ_PAR_NAME2
#  undef MSGOBJ_PAR_NAME2
#endif

#ifdef MSGOBJ_PAR_NAME3
#  undef MSGOBJ_PAR_NAME3
#endif

#ifdef MSGOBJ_PAR_NAME4
#  undef MSGOBJ_PAR_NAME4
#endif

#ifdef MSGOBJ_PAR_NAME5
#  undef MSGOBJ_PAR_NAME5
#endif

#ifdef MSGOBJ_PAR_NAME6
#  undef MSGOBJ_PAR_NAME6
#endif

#ifdef MSGOBJ_PAR_NAME7
#  undef MSGOBJ_PAR_NAME7
#endif

#ifdef MSGOBJ_PAR_NAME8
#  undef MSGOBJ_PAR_NAME8
#endif

#undef MSGOBJ_PAR_NUM
#undef MSGOBJ_CLASSNAME
#undef MSGOBJ_CLASSNAME_GEN
#undef MSGOBJ_CLASSNAME_STR
#undef BASECLASS
#undef TEMPLATE_EXPR
#undef IMSGOBJ_BASE_CLASS

#endif //  #ifndef MSGOBJ_PAR_NUM
