/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_CORALEXCEPTION_H_
#define CORALMESSAGING_CORALEXCEPTION_H_

#include "CoralMessaging/base.h"
#include <typeinfo>

START_CORALMESSAGING_NAMESPACE

class IMessage;

/** Utility function sto check if a message contains a CORAL exception, and throw it in this case.
 **/
struct CoralException
{
public:
	/** Check if the given message conveys a CORAL exception. If so, reproduce the exception
	 * and throw it. */
	static void checkAndThrow(const IMessage& msg);
	
	/** Map the CORAL exception identifier to the CORAL exception type. */
	static uint32_t getID(const std::type_info& ti);
};

END_CORALMESSAGING_NAMESPACE

#endif /* CORALMESSAGING_CORALEXCEPTION_H_ */
