/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#ifndef MESSAGEFORMATTER_H_
#define MESSAGEFORMATTER_H_

#include "CoralMessaging/Pointers.h"

START_CORALMESSAGING_NAMESPACE

namespace CTL {
	class MessageBuffer;
} // namespace CTL

class IMessage;

namespace Message {

/** Class responsible for creating a message object out of a CTL message buffer. */
class MessageFormatter
{
public:
	/// Format the content of the message buffer into a message object. Get the message
	/// type from the opcode. Return the message object if the message is syntactically
	/// correct. Return zero pointer in case of syntax error.
	static Pointer<IMessage>::Shared format(CTL::MessageBuffer& mbuf);
};

} // namespace Message 

END_CORALMESSAGING_NAMESPACE

#endif /*MESSAGEFORMATTER_H_*/
