/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef TCPSOCKETSELECTOR_H_
#define TCPSOCKETSELECTOR_H_

#include <unistd.h>

#include "CoralBricks/MonitorObject.h"
#include "CoralMessaging/Pointers.h"
#include "CoralMessaging/Timeout.h"

START_CORALMESSAGING_NAMESPACE
// TODO : change it, according to an abstract interface.
class ICoralIOHandler;

namespace Tcp {

class TcpSocket;

class TcpSocketSelector : public MonitorObject
{
public:
	TcpSocketSelector();
	virtual ~TcpSocketSelector();
	void insert(Pointer<ICoralIOHandler>::Shared sh);	
	void insert(TcpSocket& sock);
	void remove(Pointer<ICoralIOHandler>::Shared sh);
	bool eventOccurred(Pointer<ICoralIOHandler>::Shared sh);
	bool eventOccurred(TcpSocket& sock);
	bool wait(const Timeout& to);
	bool allServiceClosed();

private:
    fd_set _registered;
    fd_set _active;
    int _servNum;
};

} // namespace Tcp

END_CORALMESSAGING_NAMESPACE

#endif /* TCPSOCKETSELECTOR_H_ */
