/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "CoralMessaging/ICoralIOHandler.h"
#include "CoralMessaging/CTL/CTLPacket.h"

START_CORALMESSAGING_NAMESPACE

namespace CTL {

Packet::Packet(const CoralProtocol::PacketHeader& header) 
	: _header(header), _pload(_header.payloadSize(), 0) 
{
	// EMPTY
}

Packet::~Packet() 
{
	// EMPTY
}
   
bool Packet::write(ICoralIOHandler& out) const 
{
   	if (_header.write(out)) return out.write(_pload.c_str(), _pload.size());
   	return false;
}
    
const CoralProtocol::PacketHeader& Packet::header() const 
{
	return _header;
} 

std::string& Packet::payload() 
{
	return _pload;
}

} // namespace CTL

END_CORALMESSAGING_NAMESPACE

