/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "CoralMessaging/Utils/Error.h"

START_CORALMESSAGING_NAMESPACE

template<>
void Error<true>::_logSystemError()
{
    theLogger() << " (System reported: \"" << addErr << "\")";
}


template<>
const char* Error<false, Err::e_detailedReport>::what() const throw()
{
    return _description().c_str();
}


void Err::log(const char* aFile, const char* aFunc, const int aLineNo)
{
    theLogger().newLog(coral::Debug, aFile, aFunc, aLineNo) << _description();
    _logSystemError();
    theLogger() << commit;
} 


const char* Err::what() const throw()
{
    return "Unknown error";
}

std::string Err_System::_description() const
{
    return _userDesc;
}

std::string Err_Custom::_description() const
{
    return _desc;
}

END_CORALMESSAGING_NAMESPACE
