/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include <iostream>

#include "CoralMessaging/Utils/Logger.h"
#include "MsgReporter.h"

START_CORALMESSAGING_NAMESPACE

MsgReporter::MsgReporter()
	: coral::MsgReporter()
{
	setOutputLevel(coral::Verbose);
}

void MsgReporter::report(const int level, const std::string& src, const std::string& msg)
{
	if (level < outputLevel()) return;
	const char* levelStr = "Unknown";
	switch (level)    {
#define SET(x)  case coral::x:  levelStr=#x;  break 
    SET( Nil );
    SET( Verbose );
    SET( Debug );
    SET( Info );
    SET( Warning );
    SET( Error );
    SET( Fatal );
    case coral::Always:
      levelStr="Success";
      break;
    default:
      levelStr="Unknown";
      break;
#undef SET
	}

	std::cout << levelStr << Logger::separator() << src << Logger::separator() << msg << "\n";
}

END_CORALMESSAGING_NAMESPACE
