/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include <typeinfo>

#include "CoralMessaging/CAL/MsgObj/AttributeTypeTools.h"
#include "AttributeTypeToolsTest.h"

START_CORALMESSAGING_NAMESPACE

using CAL::MsgObj::AttributeTypeTools;

void AttributeTypeToolsTest::testTypeMap()
{
	const int NumberOfAttributeTypes = 18;
	CPPUNIT_ASSERT_EQUAL(NumberOfAttributeTypes, BOOST_PP_SEQ_SIZE(CORALMESSAGING_ATTRIBUTETYPETOOLS_TYPELIST));
	// Check the first index
	const uint32_t LongLongProtocolID = 10;
	CPPUNIT_ASSERT_EQUAL(LongLongProtocolID, AttributeTypeTools::ProtocolID(typeid(long long)));
	const uint32_t CharProtocolID = 2;
	CPPUNIT_ASSERT_EQUAL(CharProtocolID, AttributeTypeTools::ProtocolID(typeid(char)));
	const uint32_t SmallestProtocolID = 1;
	CPPUNIT_ASSERT_EQUAL(SmallestProtocolID, AttributeTypeTools::ProtocolID(typeid(bool)));
	// Check the last index
	const uint32_t HighestProtocolID = NumberOfAttributeTypes;
	CPPUNIT_ASSERT_EQUAL(HighestProtocolID, AttributeTypeTools::ProtocolID(typeid(coral::TimeStamp)));

	#define CODE_GEN(r, data, i, TYPENAME) \
		CPPUNIT_ASSERT_EQUAL(static_cast<uint32_t>(i) + 1, AttributeTypeTools::ProtocolID(typeid(TYPENAME)));

	BOOST_PP_SEQ_FOR_EACH_I(CODE_GEN, @, CORALMESSAGING_ATTRIBUTETYPETOOLS_TYPELIST)
	#undef CODE_GEN
}

END_CORALMESSAGING_NAMESPACE
