/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_TESTS_DATASTRINGSTREAMTEST_H_
#define CORALMESSAGING_TESTS_DATASTRINGSTREAMTEST_H_

#include "CoralIOHandlerTestBase.h"
#include "TestBase.h"

START_CORALMESSAGING_NAMESPACE

#define TEST_NAMES (testReadWrite)(testReadWriteAll)(testReadFailure)(testWriteFailure)(testWaitForData)

class DataStringStreamTest: public CPPUNIT_NS :: TestFixture, public CoralIOHandlerTestBase
{
    CPPUNIT_TEST_SUITE (DataStringStreamTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void);
    void tearDown (void);
    
protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	static void _forceFailure(ICoralIOHandler& ioh);
};

#undef TEST_NAMES

END_CORALMESSAGING_NAMESPACE

#endif /*CORALMESSAGING_TESTS_DATASTRINGSTREAMTEST_H_*/
