/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_TESTS_MESSAGESTREAMREADERTEST_H_
#define CORALMESSAGING_TESTS_MESSAGESTREAMREADERTEST_H_

#include "CoralMessaging/Pointers.h"
#include "CoralMessaging/Stream/DataStringStream.h"

#include "TestBase.h"

START_CORALMESSAGING_NAMESPACE

#define TEST_NAMES (testReadingSimpleValues)(testWritingPointerVector)(testReadingPointerVector)
#define CLASS_NAME MessageStreamReaderTest

class CLASS_NAME : public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (CLASS_NAME);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	template<class T> T _testReadingValue(const T& val);

	typedef Pointer<Stream::DataStringStream>::Shared StrType;
};

#undef TEST_NAMES
#undef CLASS_NAME

END_CORALMESSAGING_NAMESPACE

#endif /* #ifndef CORALMESSAGING_TESTS_MESSAGESTREAMREADERTEST_H_ */
