/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_TESTS_QUERYREPRESENTATIONTEST_H_
#define CORALMESSAGING_TESTS_QUERYREPRESENTATIONTEST_H_

#include "CoralMessaging/Stream/DataStringStream.h"
#include "CoralMessaging/CAL/MsgObj/QueryRepresentation.h"
#include "TestBase.h"

START_CORALMESSAGING_NAMESPACE

using CAL::MsgObj::QueryRepresentation;

#define TEST_NAMES (testEquality)(testEncodeDecode)(testReplay)(testAssign)\
	(testCopy)(testParameterEncoderRW)(testSharedAttributeInSetCondition)

class QueryRepresentationTest: public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (QueryRepresentationTest);
    BOOST_PP_SEQ_FOR_EACH(TESTBASE_TESTDEF, ~, TEST_NAMES);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void) {};
    void tearDown (void) {};

protected:
	BOOST_PP_SEQ_FOR_EACH(TESTBASE_METHODEF, ~, TEST_NAMES)

private:
	typedef Pointer<Stream::DataStringStream>::Shared StrType;

	static void _SetupObject(QueryRepresentation& qr);
};

#undef TEST_NAMES

END_CORALMESSAGING_NAMESPACE

#endif /* #ifndef CORALMESSAGING_TESTS_QUERYREPRESENTATIONTEST_H_ */
