/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "TcpSocketTest.h"

START_CORALMESSAGING_NAMESPACE

void TcpSocketTest::setUp (void)
{
	theLogger().setLogOff();
	_serverFixture.reset(new TestSocketServer);
}

void TcpSocketTest::tearDown (void) 
{
	theLogger().setLogOn();
}

void TcpSocketTest::testReadWrite()
{
	_testReadWrite(_serverFixture->client(), _serverFixture->server());
}

void TcpSocketTest::testReadWriteAll()
{
	_testReadWriteAll(_serverFixture->client(), _serverFixture->server());
}

void TcpSocketTest::testReadFailure()
{
	// TODO: modify the base tests to use fork
	//_testReadFailure(_serverFixture->client(), _serverFixture->server(), TcpSocketTest::_forceFailure);
	//_serverFixture.reset(new TestSocketServer);
}

void TcpSocketTest::testWriteFailure()
{
	// TODO: modify the base tests to use fork
	//_testWriteFailure(_serverFixture->client(), _serverFixture->server(), TcpSocketTest::_forceFailure);
	//_serverFixture.reset(new TestSocketServer);
}

void TcpSocketTest::testWaitForData()
{
	_testWaitForData(_serverFixture->client(), _serverFixture->server());
}

void TcpSocketTest::_forceFailure(ICoralIOHandler& ioh)
{
	Tcp::TcpSocket& tsock = dynamic_cast<Tcp::TcpSocket&>(ioh);
	tsock.close();
}

END_CORALMESSAGING_NAMESPACE
