/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_TESTQUERYDEFINITION_H
#define CORALMESSAGING_TESTQUERYDEFINITION_H

#include <vector>

#include "RelationalAccess/IQueryDefinition.h"
#include "CoralMessaging/CAL/MsgObj/QueryRepresentation.h"
#include "CoralMessaging/Pointers.h"

#include "TestBase.h"

START_CORALMESSAGING_NAMESPACE

using CAL::MsgObj::QueryRepresentation;

class TestQueryDefinition : virtual public IQueryDefinition
{
public:
	TestQueryDefinition(const std::string& schemaName);

	virtual void setDistinct();

    //insert
    virtual void addToOutputList(const std::string& expression, std::string alias = "");

    //insert
    virtual void addToTableList(const std::string& tableName, std::string alias = "");

    //insert
    virtual IQueryDefinition& defineSubQuery(const std::string& alias);

    virtual void setCondition(const std::string& condition, const AttributeList& inputData);

    virtual void groupBy(const std::string& expression);

    // insert
    virtual void addToOrderList(const std::string& expression);

    virtual void limitReturnedRows(int maxRows = 1, int offset = 0);

    virtual IQueryDefinition& applySetOperation(SetOperation opetationType);

    QueryRepresentation& repr() {return _eqr;}

private:
    QueryRepresentation _eqr;
	std::vector<Pointer<TestQueryDefinition>::Shared> _subQueries;
	Pointer<TestQueryDefinition>::Shared _setQuery;
};

END_CORALMESSAGING_NAMESPACE

#endif // #ifndef CORALMESSAGING_TESTQUERYDEFINITION_H
