/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALMESSAGING_TESTS_TESTSOCKETSERVER_H_
#define CORALMESSAGING_TESTS_TESTSOCKETSERVER_H_

#include "CoralMessaging/Tcp/TcpSocket.h"

START_CORALMESSAGING_NAMESPACE

class TestSocketServer
{
public:
	TestSocketServer();
	virtual ~TestSocketServer() {};
	
	Tcp::TcpSocket& client()
	{
		return *_client;
	}
	
	Tcp::TcpSocket& server()
	{
		return *_server;
	}
	
private:
	// -------------------- methods --------------------------------------------
	void _connect();
	
	// -------------------- static data ----------------------------------------
	static const std::string& _Hostname()
	{
		static std::string h("127.0.0.1");
		return h;
	}
	
	static const int _Port = 8081;
	
	// -------------------- member data ----------------------------------------
	Pointer<Tcp::TcpSocket>::Shared _client;
	Pointer<Tcp::TcpSocket>::Shared _server;
};

END_CORALMESSAGING_NAMESPACE

#endif /*CORALMESSAGING_TESTS_TESTSOCKETSERVER_H_*/
