/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "CoralMessaging/CAL/TypeInfoMap.h"
#include "TypeInfoMapTest.h"

START_CORALMESSAGING_NAMESPACE

using CAL::TypeInfoMap;

struct TypeInfoMapTest_TestClass : public TypeInfoMap<int>
{
	enum {E_Int, E_Double};

	TypeInfoMapTest_TestClass()
		: TypeInfoMap<int>()
	{
		_map[&typeid(int)] = E_Int;
		_map[&typeid(double)] = E_Double;
	}
};

void TypeInfoMapTest::test()
{
	TypeInfoMapTest_TestClass m;
	CPPUNIT_ASSERT_EQUAL(static_cast<int>(TypeInfoMapTest_TestClass::E_Int), m(typeid(int)));
	CPPUNIT_ASSERT_EQUAL(static_cast<int>(TypeInfoMapTest_TestClass::E_Double), m(typeid(double)));
}

END_CORALMESSAGING_NAMESPACE
