/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "TestBase.h"

#include "CoralMessaging/Utils/Logger.h"

#include "PacketReaderTest.h"
#include "MessageReceiverTest.h"
#include "MessageFormatterTest.h"
#include "CTLMessageBufferTest.h"
#include "CoralExceptionTest.h"
#include "TcpSocketTest.h"
#include "DataStringStreamTest.h"
#include "MessageStreamReaderTest.h"
#include "FloatRepresentationTest.h"
#include "QueryRepresentationTest.h"
#include "ParameterCodecsTest.h"
#include "MessageObjectTest.h"
#include "AttributeTypeToolsTest.h"
#include "TypeInfoMapTest.h"
#include "CppType_ProtocolID_MapTest.h"
#include "AttributeListRepresentationTest.h"

START_CORALMESSAGING_NAMESPACE

// Registered tests
// comment out the test that you do not want to run
CPPUNIT_TEST_SUITE_REGISTRATION (PacketReaderTest);
CPPUNIT_TEST_SUITE_REGISTRATION (CTL::MessageBufferTest);
CPPUNIT_TEST_SUITE_REGISTRATION (MessageStreamReaderTest);
CPPUNIT_TEST_SUITE_REGISTRATION (MessageFormatterTest);
CPPUNIT_TEST_SUITE_REGISTRATION (MessageReceiverTest);
CPPUNIT_TEST_SUITE_REGISTRATION (CoralExceptionTest);
//CPPUNIT_TEST_SUITE_REGISTRATION (DataStringStreamTest);
CPPUNIT_TEST_SUITE_REGISTRATION (TcpSocketTest);
CPPUNIT_TEST_SUITE_REGISTRATION (FloatRepresentationTest);
CPPUNIT_TEST_SUITE_REGISTRATION (QueryRepresentationTest);
CPPUNIT_TEST_SUITE_REGISTRATION (ParameterCodecsTest);
CPPUNIT_TEST_SUITE_REGISTRATION (MessageObjectTest);
CPPUNIT_TEST_SUITE_REGISTRATION (AttributeTypeToolsTest);
CPPUNIT_TEST_SUITE_REGISTRATION (TypeInfoMapTest);
CPPUNIT_TEST_SUITE_REGISTRATION (CppType_ProtocolID_MapTest);
CPPUNIT_TEST_SUITE_REGISTRATION (AttributeListRepresentationTest);

END_CORALMESSAGING_NAMESPACE

int main ()
{
	return coral::UnitTests::run();
}
