/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALPROTOCOL_INSULATION_EXCEPTION_H
#define CORALPROTOCOL_INSULATION_EXCEPTION_H

#ifdef CORAL_SEALED

#include <exception>
#include <string>

namespace coral {

/// Base exception class for the CORAL system
class Exception : public std::exception 
{
public:
	/// Constructor
	Exception(const std::string& message, const std::string& methodName, const std::string& moduleName);

	Exception() {}

	/// Destructor
	virtual ~Exception() throw() {}

	void setMessage(const std::string& message) 
	{
		m_message = message;
	}

	/// The error reporting method
	virtual const char* what() const throw() 
	{
		return m_message.c_str();
	}

private:
	/// The name of the module which threw the exception
	std::string m_message;
};

} // namespace coral

#else // #ifdef CORAL_SEALED

#include "CoralBase/Exception.h"

#endif // #ifdef CORAL_SEALED

#endif // #ifndef CORALPROTOCOL_INSULATION_EXCEPTIONS_H
