#ifndef CORALPROTOCOL_UTILS_H_
#define CORALPROTOCOL_UTILS_H_

#include "base.h"
#include "arch.h"

START_CORALPROTOCOL_NAMESPACE

namespace Utils {

inline uint16_t swap_word(const uint16_t x)
{
    return ((0x00FF & x) << 8) |
         ((0xFF00 & x) >> 8);
}

inline uint32_t swap_word(const uint32_t x)
{
    return ((0x000000FFul & x) << 24) |
         ((0x0000FF00ul & x) << 8) |
         ((0x00FF0000ul & x) >> 8) |
         ((0xFF000000ul & x) >> 24);
}

inline uint64_t swap_word(const uint64_t x)
{
    return
         ((0x00000000000000FFull & x) << 56) |
		 ((0x000000000000FF00ull & x) << 40) |
		 ((0x0000000000FF0000ull & x) << 24) |
		 ((0x00000000FF000000ull & x) << 8) |
		 ((0x000000FF00000000ull & x) >> 8) |
		 ((0x0000FF0000000000ull & x) >> 24) |
		 ((0x00FF000000000000ull & x) >> 40) |
		 ((0xFF00000000000000ull & x) >> 56);
}

} // namespace Utils

END_CORALPROTOCOL_NAMESPACE

#endif // #ifndef CORALPROTOCOL_UTILS_H_
