/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include <boost/preprocessor/stringize.hpp>
#include <boost/preprocessor/seq/for_each.hpp>
#include <boost/preprocessor/seq/seq.hpp>

#include "CoralProtocol/Opcode.h"

START_CORALPROTOCOL_NAMESPACE

const std::string& Opcode::name(uint8_t code)
{
	#define CODE_GENERATOR(r, data, MSGNAME) \
		case BOOST_PP_CAT(E_, MSGNAME): \
		{\
			static std::string name(BOOST_PP_STRINGIZE(MSGNAME)); \
			return name; \
		}

	switch (code) 
	{		
		BOOST_PP_SEQ_FOR_EACH(CODE_GENERATOR, ~, OPCODE_LABELS);
	default:
		// should not get here..
		CORALPROTOCOL_DEBUG_ASSERT(0);
		static std::string name("__undefined__");
		return name;
	}
		
	#undef CODE_GENERATOR
}

END_CORALPROTOCOL_NAMESPACE

