/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_CLONEABLE_H_
#define CORALSERVER_CLONEABLE_H_

#include "CoralServer/base.h"

START_CORALSERVER_NAMESPACE

class Cloneable
{
public:
	virtual ~Cloneable() {};
	virtual Cloneable* clone() const = 0;
};

// Utility function for non-cloneable types
template<class T> inline T* clone(const T& a) {
	return new T(a);
}

// for cloneables
template <> inline Cloneable* clone(const Cloneable& a) {
	return a.clone();
}

END_CORALSERVER_NAMESPACE

#endif /*CORALSERVER_CLONEABLE_H_*/
