/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "CoralMessaging/MessageReceiver.h"

#include "TcpSocketAcceptor.h"
#include "CoralDataAcceptor.h"
#include "MessageHandler.h"
#include "MessageHandler.h"

START_CORALSERVER_NAMESPACE

void CoralDataAcceptor::handleEvents(Pointer<ICoralIOHandler>::Shared sh)
{
	DEBUG_ASSERT(sh.get());
	Pointer<TcpSocket>::Shared newSock = TcpSocketAcceptor::Accept(dynamic_cast<TcpSocket&>(*sh));
	
	if (newSock.get()) {
		boost::function0<void> op = boost::bind(&CoralDataAcceptor::_startMessageHandling_a, this, newSock);
		_enqueue(op);
	}
}

void CoralDataAcceptor::_startMessageHandling_a(Pointer<ICoralIOHandler>::Shared sock)
{
	CORALMESSAGING_NAMESPACE_NAME::MessageReceiver receiver(sock);
	MessageHandler handler;
	
	while(1) {
		_TIMEOUT().actualize();
		bool res = receiver.receive(_TIMEOUT());
		if (res) handler.handle(receiver.message(), receiver.from());
	}
}

END_CORALSERVER_NAMESPACE
