/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_CORALDATAACCEPTOR_H_
#define CORALSERVER_CORALDATAACCEPTOR_H_

#include "CoralMessaging/ICoralIOHandler.h"

#include "Pointers.h"
#include "IEventHandler.h"
#include "ActiveObject.h"
#include "ThreadPool.h"

START_CORALSERVER_NAMESPACE

using CORALMESSAGING_NAMESPACE_NAME::ICoralIOHandler;

class CoralDataAcceptor : public IEventHandler, public ActiveObject<ThreadPool::ThreadPool>
{
public:
	CoralDataAcceptor() : ActiveObject<ThreadPool::ThreadPool>() {}
	virtual ~CoralDataAcceptor() {};
	virtual void handleEvents(Pointer<ICoralIOHandler>::Shared sh);
	
private:
	void _startMessageHandling_a(Pointer<ICoralIOHandler>::Shared sock);
	
	static Timeout& _TIMEOUT() {
		static InfiniteTimeout td;
		return td;
	}
};

END_CORALSERVER_NAMESPACE

#endif /*CORALSERVER_CORALDATAACCEPTOR_H_*/
