/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_ENVIRONMENT_H_
#define CORALSERVER_ENVIRONMENT_H_

#include <map>

#include "CoralServer/base.h"

START_CORALSERVER_NAMESPACE

class Environment {
public:
	Environment();

    void setup(int argc, char** argv);

    template <class RET> RET get(const std::string& aVariable)
    {
    	const std::string& str = _get_str(aVariable);
    	return boost::lexical_cast<RET>(str);
    }

private:
    const std::string& _get_str(const std::string& aVariable);

    typedef std::map<std::string, std::string> _t_vars;
    _t_vars _vars;
};

inline Environment& theEnvironment()
{
    static Environment e;
    return e;
}

END_CORALSERVER_NAMESPACE

#endif // #ifndef CORALSERVER_ENVIRONMENT_H_

