/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_IEVENTDEMULTIPLEXER_H_
#define CORALSERVER_IEVENTDEMULTIPLEXER_H_

#include "IServiceHandler.h"
#include "SharedPointable.h"

START_CORALMESSAGING_NAMESPACE

class TimeDifference;

class IEventDemultiplexer : public SharedPointable<IEventDemultiplexer>
{
public:
	virtual ~IEventDemultiplexer() {};
	virtual void insert(const IServiceHandler::ptr sh) = 0;
	virtual void remove(const IServiceHandler::ptr sh) = 0;
	virtual bool eventOccurred(IServiceHandler::ptr sh) = 0;
	virtual bool wait(const TimeDifference& td) = 0;
	virtual bool allServiceClosed() = 0;
};

END_CORALMESSAGING_NAMESPACE

#endif /*CORALSERVER_IEVENTDEMULTIPLEXER_H_*/
