/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef NULLTHREADTRAITS_H_
#define NULLTHREADTRAITS_H_

/**
 * Include this file only from SynchTraits. If you include it from elsewhere,
 * you will get compilation error.
 */ 

#ifndef __THREADTRAITS_H_GUARD__
  #error File is included from elsewhere that SynchTraits.h
#endif

#include "base.h"

START_CORALSERVER_NAMESPACE

typedef NullMutex int;

class NullCondition {
	
};

class NullLock {
	explicit NullLock(const NullMutex&) {};
};

struct SynchTraits {
	typedef NullMutex              MUTEX;
	typedef NullCondition          CONDITION;
	typedef NullLock               LOCK;
};

END_CORALSERVER_NAMESPACE

#endif /*NULLTHREADTRAITS_H_*/
