/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_REFERENCECOUNTED_H_
#define CORALSERVER_REFERENCECOUNTED_H_

#include "Error.h"

START_CORALSERVER_NAMESPACE

class ReferenceCounted 
{
public:
	ReferenceCounted() : _refCount(0) {};
	virtual ~ReferenceCounted() {};

	void addReference() { ++_refCount; }
	
	void removeReference() {
		DEBUG_ASSERT(isReferenced());
		--_refCount; 
	}
	
	bool isReferenced() const { return _refCount > 0; }
	
private:
	int _refCount;
};

END_CORALSERVER_NAMESPACE

#endif /* CORALSERVER_REFERENCECOUNTED_H_ */
