/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef SCOPEDRESOURCE_H_
#define SCOPEDRESOURCE_H_

#include "CoralServer/base.h"

START_CORALSERVER_NAMESPACE

template<class OP_TYPE> class ScopedResource : private boost::noncopyable
{
public:
	ScopedResource(const OP_TYPE& op) : _op(op) {}
	~ScopedResource() { _op(); }
	
private:
	OP_TYPE _op;
};

template<class OP_TYPE> inline ScopedResource<OP_TYPE> makeScopedResource(OP_TYPE& op) 
{
	return ScopedResource<OP_TYPE>(op);
}

END_CORALSERVER_NAMESPACE

#endif /*SCOPEDRESOURCE_H_*/
