/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "Stoppable.h"

START_CORALSERVER_NAMESPACE

void Stoppable::stop() 
{
	// TODO Proper destruction of workers. Now the workers exists till the lifetime
	// of the application. Should the pool be notified?
MONITOR_START_CRITICAL
	_command = STOP;
MONITOR_END_CRITICAL
	waitUntilStop();
}

void Stoppable::waitUntilStop() 
{
MONITOR_START_CRITICAL
	while (isReferenced()) _taskStopped.wait(MONITOR_LOCK);
MONITOR_END_CRITICAL	
}

void Stoppable::_taskFinished()
{
	bool isref = true;
MONITOR_START_CRITICAL
	removeReference();
	_taskStopped.notify_all();
	isref = isReferenced();
MONITOR_END_CRITICAL
	if (!isref) _gotUnreferenced();
}

bool Stoppable::_isToStop() const 
{
	return _command == STOP;
}

END_CORALSERVER_NAMESPACE
