/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef STOPPABLE_H_
#define STOPPABLE_H_

#include <boost/scoped_ptr.hpp>
#include <boost/bind.hpp>

#include "CoralBricks/MonitorObject.h"

#include "ReferenceCounted.h"

START_CORALSERVER_NAMESPACE

class Stoppable : public MonitorObject, protected ReferenceCounted {
public:
	virtual ~Stoppable() {}
	void stop();
	void waitUntilStop();
	
protected:
	bool _isToStop() const;
	void _taskFinished();
	virtual void _gotUnreferenced() {};
	
private:
	typedef enum {NOTHING, STOP} _command_t;
	_command_t _command;
	
	ThreadTraits::CONDITION _taskStopped;
};

END_CORALSERVER_NAMESPACE

#endif /* STOPPABLE_H_ */
