/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "ThreadPool.h"

START_CORALSERVER_NAMESPACE

namespace ThreadPool {

ThreadPool::ThreadPool(const size_t queueSize, const size_t workerNum) 
	: Traced<ThreadPool>("ThreadPool"), _queue(queueSize) 
{
	int c = 1;
	for (size_t i = 0; i < workerNum; ++i) _workers.push_back(new Worker(_thgrp, c++));
	
	LOGGER_NEWLOG(coral::Debug) << "ThreadPool queue size: " << queueSize <<
		", number of worker threads: " << workerNum << commit;
}

ThreadPool::~ThreadPool() 
{	
	// EMPTY
}

void ThreadPool::wait()
{
	_thgrp.join_all();
}

void ThreadPool::stop()
{
	_thgrp.interrupt_all();
	//_thgrp.join_all();
}

ThreadPool::element_type ThreadPool::pop(const Timeout& td) 
{
	element_type t(_queue.pop(td));
	return t;
}

} // namespace ThreadPool

END_CORALSERVER_NAMESPACE
