/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#include "CoralMessaging/Utils/Logger.h"
#include "ThreadPoolWorker.h"
#include "ThreadPool.h"

START_CORALSERVER_NAMESPACE

namespace ThreadPool {

Worker::Worker(ThreadTraits::THREAD_GROUP& tg, const int id) 
	: _tracer("ThreadPoolWorker", id)
{
	tg.create_thread(boost::bind(&Worker::_doWork, this));	
	LOGGER_NEWLOG(coral::Info) << "Thread ID: " << boost::this_thread::get_id() << commit;
}

void Worker::_doWork() 
{
	while(1) {
		_TIMEOUT().actualize();
		ThreadPool::element_type task(ThreadPool::instance().pop(_TIMEOUT()));	

		if (task.get() != NULL) {
			LOGGER_NEWLOG(coral::Info) << _tracer.id() << " is working on " << task->id() << commit;
			task->execute();
			LOGGER_NEWLOG(coral::Info) << _tracer.id() << " finished " << task->id() << commit;
		}
	}
}

} // namespace ThreadPool

END_CORALSERVER_NAMESPACE
