/* 
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 * 
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */
#ifndef CORALSERVER_THREADPOOLWORKER_H_
#define CORALSERVER_THREADPOOLWORKER_H_

#include <boost/bind.hpp>

#include "Timeout.h"
#include "Traced.h"

START_CORALSERVER_NAMESPACE

namespace ThreadPool {

class Worker {
public:
	Worker(ThreadTraits::THREAD_GROUP& tg, const int id);	
	virtual ~Worker() {};

private:
	void _doWork();
	
	static Timeout& _TIMEOUT() {
		static InfiniteTimeout td;
		return td;
	}
	
	Traced<Worker, int> _tracer;
};

} // namespace ThreadPool

END_CORALSERVER_NAMESPACE

#endif /*CORALSERVER_THREADPOOLWORKER_H_*/
