#include "src/Task.h"
#include "src/Environment.h"
#include "TaskTest.h"

START_CORALSERVER_NAMESPACE

void TaskTest::setUp()
{
	theEnvironment().setup(0, NULL);
}

void TaskTest::testExecutingOperation(void)
{
	TestOp::value_type val(TestOp::INVALID_VALUE);
	TestOp op(val, TestOp::VALUE_1);
	Task<TestOp> t(op);
	/* Check if the initial value is correct */
	CPPUNIT_ASSERT_EQUAL(TestOp::val(TestOp::INVALID_VALUE), val);
	t.execute();
	/* Test if after invoking the task operation, the value changed */
	CPPUNIT_ASSERT_EQUAL(TestOp::val(TestOp::VALUE_1), val);
}

void TaskTest::testCatchingUnhandledException(void)
{
	TestOpThrows op;
	Task<TestOpThrows> t(op);
	/* The operation throws an exception */
	t.execute();
}

END_CORALSERVER_NAMESPACE
