#ifndef THREADPOOLTEST_H_
#define THREADPOOLTEST_H_

#include <iostream>
#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

#include "CoralServer/base.h"

START_CORALSERVER_NAMESPACE

/** Unit test for the Task class */
class ThreadPoolTest : public CPPUNIT_NS :: TestFixture
{
    CPPUNIT_TEST_SUITE (ThreadPoolTest);
    CPPUNIT_TEST (test1);
    CPPUNIT_TEST_SUITE_END ();

public:
    void setUp (void);
    void tearDown (void) {};

protected:
    void test1 (void);

private:
	/** The operation stores a value in an external (referenced) value */
	class TestOp {
	public:
		typedef int value_type;
		typedef enum enabled_value_type {INVALID_VALUE, VALUE_1, VALUE_2, VALUE_3};

		TestOp(value_type& ret, /* The external variable */
				int expected /* The value to be stored */) : _ret(ret), _exp(expected) {};

		void operator () () {
			_ret = _exp;
		};

		static value_type val(enabled_value_type e) {
			return static_cast<value_type>(e);
		}

	private:
		value_type& _ret;
		const value_type _exp;
	};
};

END_CORALSERVER_NAMESPACE

#endif /*THREADPOOLTEST_H_*/
