/*
 * Project: POOL
 * Sub-project: CORAL
 * Web site: http://pool.cern.ch/coral
 *
 * Author: Zsolt.Molnar@cern.ch (http://www.zsoltmolnar.hu)
 */

#include "src/Logger.h"

#include "ThreadPoolTest.h"
#include "TaskTest.h"
#include "SynchronizedQueueTest.h"
#include "MessageHandlerTest.h"
#include "TestBase.h"

START_CORALSERVER_NAMESPACE

// Registered tests
// comment out the test that you do not want to run
//CPPUNIT_TEST_SUITE_REGISTRATION (ThreadPoolTest);
CPPUNIT_TEST_SUITE_REGISTRATION (TaskTest);
CPPUNIT_TEST_SUITE_REGISTRATION (SynchronizedQueueTest);
CPPUNIT_TEST_SUITE_REGISTRATION (MessageHandlerTest);

END_CORALSERVER_NAMESPACE

int main ()
{
	CORALSERVER_NAMESPACE_NAME::theLogger().setLogOff();
	return coral::UnitTests::run();
}
