#!/usr/bin/python

import curses, os, signal, re, fcntl, select, sys, pty, string, random, stat, time

  
def filterme(s):
	s2 = ''
	keep = string.letters + string.digits + '_' + ';' + ':' + ' ' + '*' + '"' + '<' + '>' + '.' + ',' + '=' + '(' + ')' + '[' + ']' + '/'
	for c in s:
		if c in keep:
			s2 += c
	return s2

class StackList:

	def __init__(self, windowh):
		self.first = None
		self.last = None
		self.maximum = 500
		self.counter = 0
		self.offset = 0
		self.startpos = None
		self.windowh = windowh
		
	def __del__(self):
		pass
				
	def add(self, data):

		dif = self.windowh + 1
			
		if self.first == None:
			#pos, data, next element, previous element
			self.first = [0, data, None, None]
			self.last = self.first
			self.startpos = self.first
			dif = 1
		else:
		#check first if the position needs increasing
			dif = self.last[0] - self.startpos[0]
			#check if last element is at the maximum border
			#delete the first element
			if (self.last[0] - self.offset) == self.maximum:
				self.first = self.first[2]
				self.first[3] = None
				#increase offset
				self.offset += 1

			h = [self.last[0] + 1, data, None, self.last]
			self.last[2] = h
			self.last = h
		#increase position if needed
		if dif == self.windowh:
			self.posp()

	def begin(self):
		return self.first

	def end(self):
		return self.last
		
	def next(self, element):
		dif = element[0] - self.startpos[0]
		if dif < self.windowh:
			return element[2]
		else:
			return None
				
	def position(self):
		return self.startpos
		
	def maxh(self, pos):
		return pos - self.startpos[0] == self.windowh

	def posp(self):
		if self.startpos <> None:
			dif = self.last[0] - self.startpos[0]
			if dif > self.windowh:
				if self.startpos[2] <> None:
					self.startpos = self.startpos[2]
		
	def posm(self):
		if self.startpos <> None:
			if self.startpos[3] <> None:
				self.startpos = self.startpos[3]

class ContentFilter:

	def __init__(self):
		self.f = []
		
	def __del__(self):
		pass
	
	def add(self, key, posc, posb):
		self.f.append([key, posc, posb])

	def find(self, keys):
		if keys == None:
			return self.f[0]

		for key in keys:
			for i in self.f:
				if key == i[0]:
					return i
		return self.f[0]

class Decorator:

	def __init__(self, chandle, cf):
		self.mheight = 3
		self.sc = chandle.getScreen()
		self.sc.clear()
#		self.status(0, 0, "", "")
#		self.controls()
		y, x = self.sc.getmaxyx()
		self.display = self.sc.subwin(y - 4, x, 3, 0)

		self.display.hline(2, 1, "-", x - 2)

		self.display.hline(y - self.mheight - 6, 1, "-", x - 2)
			
		y, x = self.display.getmaxyx()
		self.tdata = [['Main', StackList(y - self.mheight - 6), 0], ['Error', StackList(y - self.mheight - 6), 0]]
		self.tpos = 1
		
		self.cf = cf
		
	def __del__(self):
		pass
		
	def refresh(self):
		y, x = self.sc.getmaxyx()
		self.display.box()
		self.display.addstr(0, x - 20, '< command output >')
		self.display.addstr(1 ,2 ,"previous thread [<-] | next thread [->]")

		self.display.refresh()

#	def status(self, cp, np, connect, error):
#		y, x = self.sc.getmaxyx()
#		self.sc.hline(y - 2, 0, "-", x, curses.color_pair(1))
#		self.sc.hline(y - 1, 0, " ", x, curses.color_pair(1))

#		self.sc.insstr(y - 1 ,0 ," %d/%d | %s | %s" % (cp + 1, np, connect, error), curses.color_pair(1))
		
#		self.sc.refresh()

	def inputHandle(self, c):
		if c == curses.KEY_LEFT:
			self.previousThread()
		elif c == curses.KEY_RIGHT:
			self.nextThread()
		elif c == curses.KEY_UP:
			if self.tpos > 0:
				data = self.tdata[self.tpos - 1]
				slpos = data[1].position()
				if slpos <> None:
					if data[2] == slpos[0]:
						data[1].posm()
						data[2] = data[1].position()[0]
					else:
						if data[2] > 0:
							data[2] = data[2] - 1
				self.refreshDisplay(self.tpos)
		elif c == curses.KEY_DOWN:
			if self.tpos > 0:
				data = self.tdata[self.tpos - 1]
				slpos = data[1].end()
				if slpos <> None:
					if data[1].maxh(data[2]):
						data[1].posp()
						if data[2] < data[1].end()[0]:
							data[2] = data[2] + 1
					else:
						if data[2] < data[1].end()[0]:
							data[2] = data[2] + 1
				self.refreshDisplay(self.tpos)
		else:
			pass
		
	def refreshDisplay(self, pos):
		s02 = "                                                                                                                                                                                                                          "
		if self.tpos == 0:
			return
			
		y, x = self.display.getmaxyx()
		self.refresh()
		self.display.addstr(0, 3, '< %d/%d: %s >' % (self.tpos, len(self.tdata), self.tdata[self.tpos - 1][0]))
		
		if pos == self.tpos:
			stacklist = self.tdata[self.tpos - 1][1]
			vpos = self.tdata[self.tpos - 1][2]
			y2 = 3
			pos2 = stacklist.position()
			while pos2 <> None:
				content01 = pos2[1][0].rstrip()
				content02 = content01[:(x-11)]
				content02 = content02 + s02[0:(x - len(content02) - 11)]
				
				keys = pos2[1][1]
				f = self.cf.find(keys)
				
				if f <> None:
					if pos2[0] == vpos:
						self.display.addstr(y2, 1, "%6d | %s" % (pos2[0], content02), curses.color_pair(f[2]))
					else:
						self.display.addstr(y2, 1, "%6d | %s" % (pos2[0], content02), curses.color_pair(f[1]))
				else:
					if pos2[0] == vpos:
						self.display.addstr(y2, 1, "%6d | %s" % (pos2[0], content02), curses.color_pair(1))
					
						self.display.hline(y - self.mheight - 1, 1, " ", x - 2)
#					self.display.addstr(y - self.mheight - 1, 1, pos2[1])
					else:
						self.display.addstr(y2, 1, "%6d | %s" % (pos2[0], content02))
				pos2 = stacklist.next(pos2)
				y2 += 1
#		if y - 3 - y2 > 1:
			for y3 in range(y2, (y - self.mheight - 2)):
				self.display.addstr(y3, 1, s02[0:(x-2)])
		self.display.move(y - 2, 2)
		self.display.refresh()
		
	def refreshThreads(self, s):
		list = ""
		for i in self.outt.keys():
			if i == s:
				list += "X"
			else:
				list += "O"
#		self.dthreads.addstr(1,2, list)
#		self.dthreads.refresh()
		
	def nextThread(self):
 		if self.tpos < len(self.tdata):
			self.tpos = self.tpos + 1
		else:
			self.tpos = 1
		self.refreshDisplay(self.tpos)
		
	def previousThread(self):
		if self.tpos > 1:
			self.tpos = self.tpos - 1
		else:
			self.tpos = len(self.tdata)
		self.refreshDisplay(self.tpos)		
		
	def __findKey__(self, key):
		tlen = len(self.tdata)
		for i in range(0, tlen):
			if self.tdata[i][0] == key:
				return i + 1
		return 0
				
	def addData(self, key, f, s):	
		pos = self.__findKey__(key)
		if pos == 0:
			y, x = self.display.getmaxyx()
			sl = StackList(y - self.mheight - 6)
			self.tdata.append([key, sl, 0])
			sl.add([s, f])
			if self.tpos == 0:
				self.tpos = 1
			self.refreshDisplay(1)
		else:
			data = self.tdata[pos - 1]
			sl = data[1]
			if sl.end() <> None:
				if data[2] == sl.end()[0]:
					sl.add([s, f])
					data[2] = sl.end()[0]
				else:
					sl.add([s, f])
			else:
				sl.add([s, f])
			self.refreshDisplay(pos)
			
	def save(self, file):
		fd = open(file, "w")
	
		tlen = len(self.tdata)
		for i in range(0, tlen):
			stacklist = self.tdata[i][1]
			pos = stacklist.begin()
			while pos <> None:
				fd.write(pos[1] + '\n')
				pos = stacklist.next(pos)
		fd.close()	
		
class MainDecorator:

	def __init__(self, ch, version, cf):
		self.version = version
		self.sc = ch.getScreen()
		self.topic = None
		self.deco = Decorator(ch, cf)
		self.refresh()

	def refresh(self):
		y, x = self.sc.getmaxyx()
		self.topic = self.sc.subwin(3, x, 0, 0)
		self.topic.box()
		self.topic.addstr(0, x - len(self.version) - 14, '< version ' + self.version + ' >')
		self.topic.addstr(1, 2, 'change display [v] | save log [s] | exit [q]')
		self.topic.refresh()
		self.deco.refresh()

	def inputHandle(self, c):
		if c == ord('v'):
			pass
		elif c == ord('s'):
			self.deco.save("log")
		else:
			self.deco.inputHandle(c)

	def inputData(self, key, f, s):
		self.deco.addData(key, f, s)
#		self.deco.refresh()

	def getch(self):
		return self.sc.getch()
		
	def displayStatus(self, text, error):
		y, x = self.sc.getmaxyx()
		self.sc.hline(y - 1, 0, " ", x)
		if error == None:
			self.sc.addstr(y - 1, 1, "Mode : " + text)
		else:
			self.sc.addstr(y - 1, 1, "Mode : " + text + " | Error : " + error, curses.color_pair(2))
		self.sc.refresh()
		
class CursorHandle:

	def __init__(self, pf, cf):
		self.stdscr = curses.initscr()
		curses.noecho()
		curses.cbreak()
		curses.start_color()
		self.stdscr.keypad(True)
		self.stdscr.nodelay(0)
		
		pos = 3
		for i in pf:
			curses.init_pair(pos, i[1], i[2])
			curses.init_pair(pos + 1, i[3], i[4])
			cf.add(i[0], pos, pos + 1)
			pos = pos + 2
		
		self.stdscr.refresh()

	def __del__(self):
#		self.close()
		pass
		
	def getScreen(self):
		return self.stdscr
		
	def getch(self):
		return self.stdscr.getch()
		
	def close(self):
		curses.nocbreak()
		self.stdscr.keypad(False)
		curses.echo()
		curses.endwin()
				
class InputHandlerPTY:

	def __init__(self, command):
		self.command = command
		
		self.pid = None
		self.stdfd = None
		self.errfd = None
		self.fstd = None
		self.ferr = None
		self.we = None

	def hopen(self):

		self.errfd, self.we = os.pipe()
		
		self.pid, self.stdfd = pty.fork()

		if self.pid == 0:

			os.close(self.errfd)

			os.dup2(self.we, sys.stderr.fileno())

			if not "CORAL_AUTH_PATH" in os.environ:
				os.environ["CORAL_AUTH_PATH"] = "/afs/cern.ch/sw/lcg/app/pool/db"
			if not "CORAL_DBLOOKUP_PATH" in os.environ:
				os.environ["CORAL_DBLOOKUP_PATH"] = "/afs/cern.ch/sw/lcg/app/pool/db"
			
			if "LD_LIBRARY_PATH" in os.environ:
				os.environ["LD_LIBRARY_PATH"] = os.environ["LD_LIBRARY_PATH"] + ":/afs/cern.ch/sw/lcg/external/root/5.18.00f/slc4_amd64_gcc34/root/lib/"
			else:
				os.environ["LD_LIBRARY_PATH"] = "/afs/cern.ch/sw/lcg/external/root/5.18.00f/slc4_amd64_gcc34/root/lib/"

			os.environ["LD_PRELOAD"] = "libCore.so"
			os.environ["ROOTSYS"] = "/afs/cern.ch/sw/lcg/external/root/5.18.00f/slc4_amd64_gcc34/root/"

			os.execv(self.command, self.command.split(" "))

		else:
			os.close(self.we)

			for fd in self.stdfd, self.errfd:
				flags = fcntl.fcntl(fd, fcntl.F_GETFL)
				fcntl.fcntl(fd, fcntl.F_SETFL, flags | os.O_NDELAY)

			self.fstd = os.fdopen(self.stdfd, "r", 0)
			self.ferr = os.fdopen(self.errfd, "r", 0)

		return self.stdfd, self.errfd
			
	def hread(self):

		pid, pstatus = os.waitpid(self.pid, os.WNOHANG)

		if pid <> 0:
			if os.WCOREDUMP(pstatus):
				pass

			time.sleep(1)
				
			self.hopen()
				
			return self.stdfd, self.errfd, None, "Program terminated with exit code : %d" % os.WTERMSIG(pstatus)

		try:
			line = self.fstd.readline()
			return self.stdfd, self.errfd, line, None
		except:
			return self.stdfd, self.errfd, None, None

	def herr(self):
		try:
			line = self.ferr.readline()
		except:
			return None
		if line == '':
			return "Read Error"
		else:
			return line
		
	def hclose(self):
		self.ferr.close()
		self.fstd.close()

		#try to kill the process
		os.kill(self.pid, signal.SIGINT)
		#wait one second
		time.sleep(0.2)
		
		pid, pexit = os.waitpid(self.pid, os.WNOHANG)

		if pid <> 0:
			return

		os.kill(self.pid, signal.SIGKILL)
		os.wait()


class InputHandlerFile:

	def __init__(self, filename):
		self.filename = filename
		self.fobj = None
		self.fd = None
		
	def hopen(self):
		self.re, self.we = os.pipe()

		try:
			self.fobj = open(self.filename, "r")
		except:
			return None

		self.fd = self.fobj.fileno()
		return self.fd, self.re
		
	def hread(self):
		if self.fobj == None:
			return None, None, None, "Error by open the file"

		line = self.fobj.readline()

		if line == '':
			self.fobj.close()
			return None, None, None, "End of file"
		else:
			return self.fd, self.re, line, None

	def herr(self):
		return None
		
	def hclose(self):
		self.fobj.close()
		os.close(self.re)
		os.close(self.we)
		
class ContentLogger:

	def __init__(self, filename):
		self.filename = filename
		os.unlink(filename)
		
	def __del__(self):
		pass
				
	def log(self, s):
		self.fobj = open(self.filename, "a")
		self.fobj.write(s + '\n')
		self.fobj.close()

		
def innListenSimple(mdecorator, userin, error):

	mdecorator.displayStatus("simple", error)

	while 1:
		c = mdecorator.getch()
		if c == ord('q'):
			break
		else:
			mdecorator.inputHandle(c)

def innListenComplex(mdecorator, inputh, userin, logger):

	stdfd, errfd = inputh.hopen()

	userfd = userin.fileno()
	
	mdecorator.displayStatus("listen on file", None)
	
	flags = fcntl.fcntl(userfd, fcntl.F_GETFL)
	fcntl.fcntl(userfd, fcntl.F_SETFL, flags | os.O_NDELAY)
		
	while 1:
	
		ready = select.select([stdfd, errfd, userfd], [], [], 1)
						
		if userfd in ready[0]:
#			c = userin.read()
			c = mdecorator.getch()

			if c == ord('q'):
				break
			else:
				mdecorator.inputHandle(c)
		
		if errfd in ready[0]:
			line = inputh.herr()

			if line <> None:
				line = filterme(line)
				mdecorator.inputData('Error', None, line)
				
			logger.log('logerror;' + line)

		if stdfd in ready[0]:
			stdfd, errfd, line, error = inputh.hread()

			if error <> None:
				mdecorator.inputData('Error', None, error)

			if stdfd == None:
				innListenSimple(mdecorator, userin, None)
				break
				
			if line <> None:
				line = filterme(line)
				m = re.search('(.*);(.*);;(.*);(0x[0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f][0-9,a-f]);(.*);(.*);(.*);(.*).*', line)
				if m != None:
					n = m.groups()
					if len(n) > 7:
						mdecorator.inputData(n[3], [n[0], n[1]], "%s | %s" % (n[2], n[7]))
				else:
					m = re.search('(.*);(.*);(.*)', line)
					if m != None:
						n = m.groups()
						mdecorator.inputData('Main', [n[0], n[1]], n[2])
					else:
##					mdecorator.inputData(c, "0x0000%d" % random.randint(0,5))
						mdecorator.inputData('Main', None, line)
				logger.log(line)
	inputh.hclose()

def checkFileType(file):
	#first check if the file is executable
	info = os.stat(file)
	
	if stat.S_ISREG(info.st_mode):
		mode = stat.S_IMODE(info.st_mode)
		ux = stat.S_IXUSR & mode
		gx = stat.S_IXGRP & mode
		ox = stat.S_IXOTH & mode
		if ux or gx or ox:
			return InputHandlerPTY(file)
		else:
			return InputHandlerFile(file)
	else:
		print "Not a file"
		
	return None
		
#main program
version = "0.0.3"

cf = ContentFilter()

pf = []
#[filter, color normal, background normal, color selected, background selected]
pf.append([None, curses.COLOR_WHITE, curses.COLOR_BLACK, curses.COLOR_BLACK, curses.COLOR_WHITE])
pf.append(["Debug", curses.COLOR_GREEN, curses.COLOR_BLACK, curses.COLOR_BLACK, curses.COLOR_GREEN])
pf.append(["Warning", curses.COLOR_YELLOW, curses.COLOR_BLACK, curses.COLOR_BLACK, curses.COLOR_YELLOW])
pf.append(["Error", curses.COLOR_RED, curses.COLOR_BLACK, curses.COLOR_BLACK, curses.COLOR_RED])
pf.append(["Info", curses.COLOR_CYAN, curses.COLOR_BLACK, curses.COLOR_BLACK, curses.COLOR_CYAN])

ch = CursorHandle(pf, cf)

cl = ContentLogger("log2")

if len(sys.argv) > 1:
	handler = checkFileType(sys.argv[1])
	if handler <> None:
			innListenComplex(MainDecorator(ch, version, cf), handler, sys.stdin, cl)
	else:
		innListenSimple(MainDecorator(ch, version, cf), sys.stdin, "No Handler found")
else:
	innListenSimple(MainDecorator(ch, version, cf), sys.stdin, "No Program Argument given")

ch.close()

