#unit test for CoralTools package 
import coral 
import unittest
import os
import sys
from schemautils.exporter import exporter

os.environ["CORAL_AUTH_PATH"]="/afs/cern.ch/sw/lcg/app/pool/db/python"
os.environ["CORAL_DBLOOKUP_PATH"]="/afs/cern.ch/sw/lcg/app/pool/db/python"

#Initialize Connection Service
svc = coral.ConnectionService()

#open session proxy for source schema providing logical service name & access mode
sourceSession = svc.connect( 'write_test', accessMode = coral.access_Update )

#open session proxy for destination schema providing logical service name & access mode
destSession = svc.connect( 'coral_test', accessMode = coral.access_Update )
  
iTable = raw_input("Enter Table Name: ")
if iTable == '':
   print 'Error!! Table Name cannot be blank!'
   sys.exit(2)

selectionclause=""
selectionparameters=coral.AttributeList()
currentCount=0
rowCount=-1

rowCachesize = input("Enter Row Cache Size: ")
if rowCachesize < 1:
   print 'Error!! Row Cache Size cannot be less than 1 !'
   sys.exit(2)

exp=exporter( sourceSession,destSession,rowCachesize )

class CoralToolsTest(unittest.TestCase):
	def setUp(self):
            print '[OVAL] setUp'
	
	def testCoralTools(self):

	 try:
	    print '[OVAL] Test CoralTools '
            exp._copytablelayout(iTable)
            exp._copydatalayout(iTable,selectionclause,selectionparameters,currentCount,rowCount)
            print "Test Completd" 
         except Exception, e:
            print "Test Failed" 
            print str(e)

	def tearDown(self):
		print '[OVAL] tearDown'

if __name__=="__main__":
	unittest.main() 	

