#include "BulkOperation.h"
#include "ErrorHandler.h"
#include "ISessionProperties.h"
#include "DomainProperties.h"

#include "RelationalAccess/SchemaException.h"
#include "CoralBase/AttributeList.h"
#include "CoralBase/Attribute.h"
#include "CoralBase/AttributeSpecification.h"
#include "CoralBase/Blob.h"

#include "CoralBase/MessageStream.h"
#include "CoralKernel/Service.h"

coral::FrontierAccess::BulkOperation::BulkOperation( const coral::FrontierAccess::ISessionProperties& properties, const coral::AttributeList& inputBuffer, int cacheSize, const std::string& statement ):
  m_properties( properties ),
  m_inputBuffer( inputBuffer ),
  m_rowsInCache( cacheSize ),
  m_rowsUsed( 0 )// ,
//   m_statementHandle( 0 ),
//   m_dataCache( 0 )
{
//   // Prepare the statement
//   sword status = OCIStmtPrepare2( m_properties.serviceContextHandle(),
//                                   &m_statementHandle,
//                                   m_properties.errorHandle(),
//                                   reinterpret_cast< CONST text* >( statement.c_str() ),
//                                   ::strlen( statement.c_str() ),
//                                   0,0,
//                                   OCI_NTV_SYNTAX, OCI_DEFAULT );
//   if ( status != OCI_SUCCESS ) {
//     coral::FrontierAccess::ErrorHandler errorHandler( m_properties.errorHandle() );
//     errorHandler.handleCase( status,"preparing the statement \"" + statement + "\"" );
//     coral::MessageStream log( m_properties.domainProperties().service(),
//                              m_properties.domainProperties().service()->name() );
//     log << coral::Error << errorHandler.message() << coral::MessageStream::endmsg;
//     this->reset();
//     throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                       "Could not prepare a new statement handle",
//                                       "IBulkOperation" );
//   }

  coral::MessageStream log( m_properties.domainProperties().service()->name() );
  log << coral::Debug << "Prepared for bulk operation statement \"" << statement << "\"" << coral::MessageStream::endmsg;


//   // Prepare the data structures
//   for ( coral::AttributeList::const_iterator iAttribute = m_inputBuffer.begin();
//         iAttribute != m_inputBuffer.end(); ++iAttribute ) {
//     const std::type_info& attributeType = iAttribute->specification().type();
//     if ( attributeType == typeid(float) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<float>( m_rowsInCache, m_properties.serverVersion() ) );
//     }
//     else if ( attributeType == typeid(double) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<double>( m_rowsInCache, m_properties.serverVersion() ) );
//     }
//     else if ( attributeType == typeid(long double) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<long double>( m_rowsInCache, m_properties.serverVersion() ) );
//     }
//     else if ( attributeType == typeid(int) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<int>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(unsigned int) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<unsigned int>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(short) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<short>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(unsigned short) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<unsigned short>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(long) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<long>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(unsigned long) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<unsigned long>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(long long) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<long long>( m_rowsInCache, m_properties.errorHandle() ) );
//     }
//     else if ( attributeType == typeid(unsigned long long) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<unsigned long long>( m_rowsInCache, m_properties.errorHandle() ) );
//     }
//     else if ( attributeType == typeid(bool) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<bool>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(char) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<char>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(unsigned char) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<unsigned char>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(std::string) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<std::string>( m_rowsInCache ) );
//     }
//     else if ( attributeType == typeid(coral::Blob) ) {
//       m_dataCache.push_back( new coral::FrontierAccess::PolymorphicTVector<coral::Blob>( m_rowsInCache ) );
//     }
//     else {
//       coral::MessageStream log( m_properties.domainProperties().service(),
//                                m_properties.domainProperties().service()->name() );
//       log << coral::Error << "Unsupported type : \"" + iAttribute->specification().typeName() + "\"" << coral::MessageStream::endmsg;
//       this->reset();
//       throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                         "Could not prepare a new bulk operation",
//                                         "IBulkOperation" );
//     }
//   }

}

coral::FrontierAccess::BulkOperation::~BulkOperation()
{
  this->reset();
}

void coral::FrontierAccess::BulkOperation::processNextIteration()
{
  // Copy the elements to the structures.
//   unsigned int iVariable = 0;
//   for ( coral::AttributeList::const_iterator iAttribute = m_inputBuffer.begin(); iAttribute != m_inputBuffer.end(); ++iAttribute, ++iVariable )
//   { 
//     m_dataCache[iVariable]->push_back( iAttribute->addressOfData(), ( iAttribute->isNull() ? -1 : 0 ) );
//   }
//   ++m_rowsUsed;

  // If necessary flush the cache.
  if ( m_rowsUsed >= m_rowsInCache )
    this->flush();
}

// static sb4 BindCallBackForStrings( dvoid* octxp,
//                         OCIBind* /* bindp */,
//                         ub4 iter, 
//                         ub4 /* index */, 
//                         dvoid** bufpp, 
//                         ub4* alenpp,
//                         ub1* piecep,
//                         dvoid** indpp )
// {
//   coral::FrontierAccess::PolymorphicTVector<std::string>* dataVector =
//     dynamic_cast< coral::FrontierAccess::PolymorphicTVector<std::string>* >( static_cast<coral::FrontierAccess::PolymorphicVector*>(octxp) );
//   const std::string& data = dataVector->data( iter );
//   *bufpp  = const_cast<char*>( data.c_str() );  
//   *alenpp = data.size() + 1;
//   *piecep = OCI_ONE_PIECE;
//   *indpp = dataVector->indicatorData( iter );
//   return OCI_CONTINUE;
// }


// static sb4
// BindCallBackForBlobs( dvoid* octxp,
//                       OCIBind* /* bindp */,
//                       ub4 iter, 
//                       ub4 /* index */, 
//                       dvoid** bufpp, 
//                       ub4* alenpp,
//                       ub1* piecep,
//                       dvoid** indpp )
// {
//   coral::FrontierAccess::PolymorphicTVector<coral::Blob>* dataVector =
//     dynamic_cast< coral::FrontierAccess::PolymorphicTVector<coral::Blob>* >( static_cast<coral::FrontierAccess::PolymorphicVector*>(octxp) );
//   coral::Blob& data = dataVector->data( iter );
//   *bufpp  = data.startingAddress();  
//   *alenpp = data.size();
//   *piecep = OCI_ONE_PIECE;
//   *indpp = dataVector->indicatorData( iter );
//   return OCI_CONTINUE;
// }


void coral::FrontierAccess::BulkOperation::flush()
{
  if ( m_rowsUsed == 0 ) return;

//   // Bind the data.
//   ub4 position = 1;
//   for ( std::vector< coral::FrontierAccess::PolymorphicVector* >::iterator iVariable = m_dataCache.begin();
//         iVariable != m_dataCache.end(); ++iVariable, ++position ) {
//     OCIBind* bindHandle = 0;
//     ub4 mode = OCI_DEFAULT;
//     if ( (*iVariable)->dty() == SQLT_STR ||
//          (*iVariable)->dty() == SQLT_LBI ) mode = OCI_DATA_AT_EXEC;
//     sword status = OCIBindByPos( m_statementHandle,
//                                  &bindHandle,
//                                  m_properties.errorHandle(),
//                                  position,
//                                  const_cast<void*>( (*iVariable)->startingAddress() ),
//                                  (*iVariable)->sizeOfObject(),
//                                  (*iVariable)->dty(),
//                                  (*iVariable)->indicatorArray(),
//                                  (*iVariable)->lengthArray(),
//                                  0, 0, 0,
//                                  mode );
//     if ( status != OCI_SUCCESS ) {
//       coral::FrontierAccess::ErrorHandler errorHandler( m_properties.errorHandle() );
//       errorHandler.handleCase( status, "binding by position the input variables" );
//       coral::MessageStream log( m_properties.domainProperties().service(),
//                                m_properties.domainProperties().service()->name() );
//       log << coral::Error << errorHandler.message() << coral::MessageStream::endmsg;
//       this->reset();
//       throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                         "Could not bind a variable",
//                                         "IBulkOperation::flush" );
//     }

//     if ( mode == OCI_DATA_AT_EXEC ) { // strings and strings are special...
//       status = OCIBindDynamic( bindHandle,
//                                m_properties.errorHandle(),
//                                static_cast<void*>(*iVariable),
//                                ( (*iVariable)->dty() == SQLT_STR ) ? &BindCallBackForStrings : &BindCallBackForBlobs,
//                                0, 0 );
//       if ( status != OCI_SUCCESS ) {
//         coral::FrontierAccess::ErrorHandler errorHandler( m_properties.errorHandle() );;
//         errorHandler.handleCase( status, "binding the array structure of input variables" );
//         coral::MessageStream log( m_properties.domainProperties().service(),
//                                  m_properties.domainProperties().service()->name() );
//         log << coral::Error << errorHandler.message() << coral::MessageStream::endmsg;
//         this->reset();
//         throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                           "Could not bind dynamically a variable",
//                                           "IBulkOperation::flush" );
//       }
//     }
//     else {
//       status = OCIBindArrayOfStruct( bindHandle,
//                                      m_properties.errorHandle(),
//                                      (*iVariable)->dataValueSkip(),
//                                      sizeof(sb2),
//                                      (*iVariable)->dataLengthSkip(),
//                                      0 );
//       if ( status != OCI_SUCCESS ) {
//         coral::FrontierAccess::ErrorHandler errorHandler( m_properties.errorHandle() );
//         errorHandler.handleCase( status, "binding the array structure of input variables" );
//         coral::MessageStream log( m_properties.domainProperties().service(),
//                                  m_properties.domainProperties().service()->name() );
//         log << coral::Error << errorHandler.message() << coral::MessageStream::endmsg;
//         this->reset();
//         throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                           "Could not bind the array structure of a variable",
//                                           "IBulkOperation::flush" );
//       }
//     }
//   }


//   // execute
//   coral::MessageStream log( m_properties.domainProperties().service(),
//                            m_properties.domainProperties().service()->name(),
//                            coral::Debug );
//   log << coral::Debug << "Executing a bulk insert (flushing the cache)" << coral::MessageStream::endmsg;
  
//   ub4 iters = m_rowsUsed;
//   sword status = OCIStmtExecute( m_properties.serviceContextHandle(),
//                                  m_statementHandle,
//                                  m_properties.errorHandle(),
//                                  iters, 0, 0, 0, OCI_DEFAULT );
//   if ( status != OCI_SUCCESS ) {
//     coral::FrontierAccess::ErrorHandler errorHandler( m_properties.errorHandle() );
//     errorHandler.handleCase( status, "executing the bulk insert statement" );
//     coral::MessageStream log( m_properties.domainProperties().service(),
//                              m_properties.domainProperties().service()->name() );
//     log << coral::Error << errorHandler.message() << coral::MessageStream::endmsg;
//     this->reset();
//     throw coral::DataEditorException( m_properties.domainProperties().service()->name(),
//                                       "Could not execute a bulk operation",
//                                       "IBulkOperation::flush" );
//   }

//   // Clear the cache
//   for ( std::vector< coral::FrontierAccess::PolymorphicVector* >::iterator iVariable = m_dataCache.begin();
//         iVariable != m_dataCache.end(); ++iVariable ) (*iVariable)->clear();
//   m_rowsUsed = 0;
}

void coral::FrontierAccess::BulkOperation::reset()
{
//   for ( std::vector< coral::FrontierAccess::PolymorphicVector* >::iterator iVariable = m_dataCache.begin(); iVariable != m_dataCache.end(); ++iVariable )
//     delete *iVariable;
  
//   m_dataCache.clear();
  m_rowsUsed = 0;

//   if ( m_statementHandle )
//   {
//     OCIStmtRelease ( m_statementHandle, m_properties.errorHandle(), 0,0, OCI_DEFAULT );
//     m_statementHandle = 0;
//   }
}
