#include "PrivilegeManager.h"
#include "Statement.h"
#include "ISessionProperties.h"
#include "DomainProperties.h"

#include "RelationalAccess/SchemaException.h"
#include "RelationalAccess/RelationalServiceException.h"

#include "CoralBase/AttributeList.h"

#include "CoralKernel/Service.h"

#include <sstream>

coral::FrontierAccess::PrivilegeManager::PrivilegeManager( const coral::FrontierAccess::ISessionProperties& properties, const std::string& tableName )
  : m_properties( properties ), m_tableName( tableName )
{
}

void coral::FrontierAccess::PrivilegeManager::grantToUser( const std::string& /*userName*/, coral::ITablePrivilegeManager::Privilege /*right*/ )
{
  throw coral::InvalidOperationException( m_properties.domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::grantToUser" );
}

void coral::FrontierAccess::PrivilegeManager::revokeFromUser( const std::string& /*userName*/, coral::ITablePrivilegeManager::Privilege /*right*/ )
{
  throw coral::InvalidOperationException( m_properties.domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::revokeFromUser" );
}

void coral::FrontierAccess::PrivilegeManager::grantToPublic( coral::ITablePrivilegeManager::Privilege /*right*/ )
{
  throw coral::InvalidOperationException( m_properties.domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::grantToPublic" );
}

void coral::FrontierAccess::PrivilegeManager::revokeFromPublic( coral::ITablePrivilegeManager::Privilege /*right*/ )
{
  throw coral::InvalidOperationException( m_properties.domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::revokeFromPublic" );
}
