#include "ViewFactory.h"
#include "ISessionProperties.h"
#include "DomainProperties.h"
#include "Statement.h"

#include "RelationalAccess/ISchema.h"
#include "RelationalAccess/SchemaException.h"
#include "RelationalAccess/RelationalServiceException.h"

#include "CoralKernel/Service.h"

coral::FrontierAccess::ViewFactory::ViewFactory( const coral::FrontierAccess::ISessionProperties& properties )
  : coral::FrontierAccess::QueryDefinition( properties )
{
}

coral::FrontierAccess::ViewFactory::~ViewFactory()
{
}

coral::IView& coral::FrontierAccess::ViewFactory::create( const std::string& viewName )
{
  throw coral::InvalidOperationException( this->sessionProperties().domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::View::create" );
  return this->sessionProperties().schema().viewHandle( viewName );
}

coral::IView& coral::FrontierAccess::ViewFactory::createOrReplace( const std::string& viewName )
{
  throw coral::InvalidOperationException( this->sessionProperties().domainProperties().service()->name(), "Frontier does not support DDL operations", "coral::FrontierAccess::View::createOrReplace" );
  return this->sessionProperties().schema().viewHandle( viewName );
}
