// -*- C++ -*-
// $Id: TestBase.h,v 1.6 2008/04/03 21:42:03 rado Exp $
#ifndef TESTBASE_H
#define TESTBASE_H

#include "RelationalAccess/AccessMode.h"

#include "CoralKernel/Context.h"

#include <string>

namespace coral
{
  class ISession;
  class IConnectionService;
  class ITypeConverter;
}

class TestBase
{
  public:
    // Constructor
    TestBase();

    // Destructor
    virtual ~TestBase();

    // The actual run method
    virtual void run() = 0;

  protected:
    // Returns a session object
    coral::ISession* connect( const std::string& connectionString,
                              const std::string& userName,
                              const std::string& password,
                              coral::AccessMode  mode=coral::ReadOnly );

    void disconnect();

    coral::ITypeConverter& typeConverter() const;
    
    // Returns CORAL connection service handle
    coral::IHandle<coral::IConnectionService> connectionService();

};

#endif
