// $Id: ConnectionApp.cpp,v 1.3 2006/12/08 15:40:57 rado Exp $
#include "ConnectionApp.h"
#include "RelationalAccess/ISession.h"
#include "RelationalAccess/ITransaction.h"
#include "RelationalAccess/ITypeConverter.h"

#include <iostream>
#include <stdexcept>


ConnectionApp::ConnectionApp( const std::string& connectionString, const std::string& userName, const std::string& password )
  : TestBase(), m_connectionString( connectionString ), m_userName( userName ), m_password( password )
{
}

ConnectionApp::~ConnectionApp()
{
}

void ConnectionApp::run()
{
  coral::ISession* session = this->connect( m_connectionString, m_userName, m_password );
  
//   if ( ! session->isUserSessionActive() )
//   {
//     throw std::runtime_error( "Session not established..." );
//   }

  std::cout << "Supported C++ types: " << std::endl;
  std::set<std::string> cppTypes = this->typeConverter().supportedCppTypes();
  
  for ( std::set<std::string>::const_iterator iType = cppTypes.begin(); iType != cppTypes.end(); ++iType )
  {
    std::cout << *iType << std::endl;
    std::cout << "                      -> "
              << this->typeConverter().sqlTypeForCppType( *iType ) << std::endl;
  }

  std::cout << "Supported SQL types: " << std::endl;
  std::set<std::string> sqlTypes = this->typeConverter().supportedSqlTypes();
  
  for ( std::set<std::string>::const_iterator iType = sqlTypes.begin(); iType != sqlTypes.end(); ++iType )
  {
    std::cout << *iType << std::endl;
    std::cout << "                      -> "
              << this->typeConverter().cppTypeForSqlType( *iType ) << std::endl;
  }

  session->transaction().start();

  session->transaction().commit();

  session->transaction().start( true );

  session->endUserSession();

//   if ( session->isUserSessionActive() )
//   {
//     throw std::runtime_error( "Session appears to be up and running !!!" );
//   }

  this->disconnect();
  
  session = this->connect( m_connectionString, m_userName, m_password );    

//   if ( ! session->isUserSessionActive() )
//   {
//     throw std::runtime_error( "Session not established..." );
//   }

  session->transaction().start();
  
  session->transaction().commit();

  session->endUserSession();
  
  delete session;

  this->disconnect();
}
