#include <iostream>
#include <exception>
#include "ConnectionApp.h"
#include "CoralBase/Exception.h"

int main( int, char** )
{
  try
  {
//    ConnectionApp app( "frontier://lxfs6043.cern.ch:8000/Frontier3D/CORAL", "CORAL", "Frontier24" );
    ConnectionApp app( "frontier://(serverurl=http://lxfs6043.cern.ch:8000/Frontier3D)/CORAL", "CORAL", "Frontier24" );
    app.run();
  }
  catch ( coral::Exception& e ) {
    std::cerr << "CORAL Exception : " << e.what() << std::endl;
    return 1;
  }
  catch ( std::exception& e ) {
    std::cerr << "C++ Exception : " << e.what() << std::endl;
    return 1;
  }
  catch (...) {
    std::cerr << "Unknown exception ..." << std::endl;
    return 1;
  }
  std::cout << "[OVAL] Success" << std::endl;
  return 0;
}
