#ifndef LFCLOOKUPSERVICE_LFCLOOKUPSERVICE_H
#define LFCLOOKUPSERVICE_LFCLOOKUPSERVICE_H

#include "RelationalAccess/ILookupService.h"
#include "SealKernel/Service.h"
#include <map>
#include <vector>

namespace coral {

  namespace LFCLookupService {

    class LFCLookupService : public seal::Service,
                             virtual public coral::ILookupService
    {
      DECLARE_SEAL_COMPONENT;

    public:
      /// Standard Constructor
      LFCLookupService( seal::Context* c );
      
      /// Standard Constructor with a component key
      LFCLookupService( seal::Context* c, const std::string& key );

      /// Standard Destructor
      virtual ~LFCLookupService();

    public:
      /* Performs a lookup for a given logical connection string.  */

      coral::IDatabaseServiceSet* lookup( const std::string& logicalName,
                                          coral::AccessMode accessMode = coral::Update,
                                          std::string authenticationMechanism = "" ) const;

    public:

      /// To log the message into Seal 
      void logMessage(  std::string& mesg );
    };

  }

}

#endif
