#ifndef LFCREPLICASERVICE_LFCFILE_H
#define LFCREPLICASERVICE_LFCFILE_H

#include <string>
#include <vector>

namespace coral {

  namespace LFCReplicaService {

    class LFCFile {

      public:

      LFCFile();

      explicit LFCFile(const std::string& absolutePath);

      LFCFile(const std::string& absoluteParentPath, const std::string& childName);

      LFCFile(const LFCFile& aFile);

      virtual ~LFCFile();

      LFCFile& operator=(const LFCFile& aFile);

      std::string fileName() const;

      const std::string& path() const;

      const std::string& guid() const;
      
      bool lookup();

      bool exists() const;

      bool isDirectory() const;

      bool isReadable() const;

      bool isWritable() const;

      bool isExecutable() const;

      const std::vector<std::string>& listFiles() const;

      private:

      std::string m_absolutePath;

      bool m_exists;

      bool m_isDir;

      bool m_readOk;

      bool m_writeOk;

      bool m_executeOk;

      std::vector<std::string> m_content;

      std::string m_guid;
      
    };
    
  }

}

#endif
