#include <cstdlib>

#include "LFCLogicalConnectionString.h"

coral::LFCReplicaService::LFCLogicalConnectionString::LFCLogicalConnectionString():m_lfcFile(){}

coral::LFCReplicaService::LFCLogicalConnectionString::LFCLogicalConnectionString(const std::string& logicalString):m_lfcFile(parseLogicalString(logicalString)){}

const coral::LFCReplicaService::LFCFile& coral::LFCReplicaService::LFCLogicalConnectionString::lfcFile() const {
  return m_lfcFile;
}

std::string coral::LFCReplicaService::LFCLogicalConnectionString::parseLogicalString(const std::string& logicalString) {
  std::string rootDir = lfcRootFolder();
  std::string absolutePath("");
  if(!logicalString.empty() && logicalString[0]== '/'){
    if (logicalString.substr(0,rootDir.size()) != rootDir){
      absolutePath.append(rootDir);
    }
    if(logicalString != "/") absolutePath.append(logicalString);
  } else {
    absolutePath.append(rootDir);
    if(!logicalString.empty()) absolutePath.append("/").append(logicalString);
  }
	return absolutePath;
}

std::string coral::LFCReplicaService::LFCLogicalConnectionString::lfcRootFolder(){
  static std::string lfcRootFolder("/database");
  char* userRootFolder_c = ::getenv("CORAL_LFC_BASEDIR");
  if(userRootFolder_c){
    std::string  userRootFolder("");
    if(userRootFolder_c[0]!='/') userRootFolder.append("/");
    userRootFolder.append(userRootFolder_c);
    return userRootFolder;
  } else {
    return lfcRootFolder;
  }
}

