#ifndef LFCREPLICASERVICE_LFCREPLICA_H
#define LFCREPLICASERVICE_LFCREPLICA_H

#include <string>
#include <vector>
#include <sys/stat.h> //mode_t in lfc_api.h
#include <lfc_api.h>

namespace coral {

  namespace LFCReplicaService {

    struct LFCFileId {
        LFCFileId();
        LFCFileId(const LFCFileId& rhs);
        LFCFileId& operator=(const LFCFileId& rhs);
        u_signed64 id;
        std::string lfcHost;
    };
    
    class LFCReplica{

      public:

      LFCReplica();

      LFCReplica(const LFCReplica& rhs);
      
      LFCFileId fileid;
      std::string pfn;
      std::string status;
      std::string serverParameter;
      std::string f_typeParameter;
      std::string poolnameParameter;
      std::string fsParameter;

    };    

    class LFCReplicaSet {
      
      public:

      LFCReplicaSet():m_replicas(){}

      virtual ~LFCReplicaSet();
      
      const std::vector<LFCReplica*>& replicas() const;

      std::vector<LFCReplica*>& replicas();
      
      private:

      std::vector<LFCReplica*> m_replicas;
    };
    
  }
}

inline
coral::LFCReplicaService::LFCFileId::LFCFileId():id(0),lfcHost(""){}

inline
coral::LFCReplicaService::LFCFileId::LFCFileId(const LFCFileId& rhs):id(rhs.id),lfcHost(rhs.lfcHost){}

inline
coral::LFCReplicaService::LFCFileId& coral::LFCReplicaService::LFCFileId::operator=(const LFCFileId& rhs){
  id = rhs.id;
  lfcHost = rhs.lfcHost;
  return *this;
}

inline
coral::LFCReplicaService::LFCReplica::LFCReplica():
  fileid(),
  pfn(""),
  status(""),
  serverParameter(""),
  f_typeParameter(""),
  poolnameParameter(""),
  fsParameter(""){}

inline
coral::LFCReplicaService::LFCReplica::LFCReplica(const LFCReplica& rhs):
  fileid(rhs.fileid),
  pfn(rhs.pfn),
  status(rhs.status),
  serverParameter(rhs.serverParameter),
  f_typeParameter(rhs.f_typeParameter),
  poolnameParameter(rhs.poolnameParameter),
  fsParameter(rhs.fsParameter){}


#endif
    
    
