// -*- C++ -*-
// $Id: DomainProperties.h,v 1.4 2008/03/26 12:00:17 rado Exp $
#ifndef MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H
#define MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H 1

#include "CoralKernel/IHandle.h"

#include <string>

namespace coral
{
  class Service;
  class ITypeConverter;
  
  namespace MySQLAccess
  {
    class Domain;
    class TypeConverter;
    
    /**
     * A simple class holding the global domain properties
     */

    class DomainProperties
    {
      public:
        /// Constructor
        explicit DomainProperties( coral::MySQLAccess::Domain* service );
        
        /// Destructor
        ~DomainProperties();

        /// Returns the pointer to the service
        coral::Service* service() const;

        /// The type converter
        coral::ITypeConverter& typeConverter() const;
        
      private:
        /// The pointer to the service
        coral::MySQLAccess::Domain*         m_service;
        /// The type converter
        coral::MySQLAccess::TypeConverter*  m_typeConverter;
    };
  }
}

#endif // MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H
