#include <vector>
#include <string>
#include <iostream>

int main( int, char** )
{
  std::vector<std::string> types; 
  types.push_back( "VARCHAR(255)" );
  types.push_back( "VARCHAR(255) BINARY" );
  types.push_back( "INTEGER(11)" );
  types.push_back( "DECIMAL(10,5)" );
  types.push_back( "FLOAT(53)" );

  for( size_t idx = 0; idx < types.size(); idx++ )
  {
    std::string t( types[idx] );
    
    unsigned int length     = 0;
    unsigned int precision  = 0;
    
    // Figure out the column (create) length  if specified
    size_t lenb = std::string::npos; size_t lene = std::string::npos;
    size_t penb = std::string::npos; size_t pene = std::string::npos;
    
    if( (lenb = t.find('(')) != std::string::npos )
    {
      lenb+=1;
      
      if( (penb = t.find(',')) != std::string::npos )
      {
        lene=penb;
        penb+=1;
        pene = t.find(')');
      }
      else
      {
        lene = t.find(')');
      }
    }
    
    if( lene != std::string::npos )
      length    = ::atol( t.substr( lenb, lene - lenb ).c_str() );
    
    if( pene != std::string::npos )
      precision = ::atol( t.substr( penb, pene - penb ).c_str() );

    std::cout << "Type: " << t << " Length: " << length << " precision: " << precision << std::endl;
  }
  
  return 0;
}
