#include "Cursor.h"
#include "OracleStatement.h"

coral::OracleAccess::Cursor::Cursor( OracleStatement* statement,
                                     const coral::AttributeList& rowBuffer ):
  m_statement( statement ),
  m_rowBuffer( rowBuffer )
{}


coral::OracleAccess::Cursor::~Cursor()
{
  this->close();
}


bool
coral::OracleAccess::Cursor::next()
{
  if ( m_statement == 0 ) return false;
  bool result = m_statement->fetchNext();
  if ( ! result ) {
    this->close();
  }
  return result;
}


const coral::AttributeList&
coral::OracleAccess::Cursor::currentRow() const
{
  return m_rowBuffer;
}


void
coral::OracleAccess::Cursor::close()
{
  if ( m_statement != 0 ) {
    delete m_statement;
    m_statement = 0;
  }
}
