#ifndef TESTBASE_H
#define TESTBASE_H

#include <string>

#include "CoralKernel/Context.h"

namespace coral
{
  class IConnection;
  class ISession;
}

class TestBase
{
public:
  // Constructor
  TestBase();

  // Destructor
  virtual ~TestBase();

  // The actual run method
  virtual void run() = 0;

protected:

  // Returns a session object
  coral::ISession* connect( const std::string& connectionString,
                            const std::string& userName,
                            const std::string& password );

private:
    
  // The connection object
  coral::IConnection*         m_connection;
};

#endif
