#include "QueriesApp.h"

#include "RelationalAccess/ISession.h"
#include "RelationalAccess/ITransaction.h"
#include "RelationalAccess/ISchema.h"
#include "RelationalAccess/ITable.h"
#include "RelationalAccess/ITableDataEditor.h"
#include "RelationalAccess/TableDescription.h"
#include "RelationalAccess/IQuery.h"
#include "RelationalAccess/ICursor.h"

#include "CoralBase/AttributeList.h"
#include "CoralBase/Attribute.h"
#include "CoralBase/AttributeSpecification.h"
#include "CoralBase/Blob.h"

#include <iostream>
#include <stdexcept>


QueriesApp::QueriesApp( const std::string& connectionString,
                        const std::string& userName,
                        const std::string& password ):
  TestBase(),
  m_connectionString( connectionString ),
  m_userName( userName ),
  m_password( password )
{}


QueriesApp::~QueriesApp()
{}


void
QueriesApp::run()
{
  coral::ISession* session = this->connect( m_connectionString,
                                            m_userName, m_password );
  session->transaction().start( true );

  coral::ISchema& schema = session->nominalSchema();

  coral::AttributeList data;
  data.extend<float>( "X" );

  coral::IQuery* query = schema.newQuery();
  query->addToOutputList( "3.21", "X" );
  query->defineOutput( data );
  query->addToTableList( "DUAL" );
  coral::ICursor& cursor = query->execute();
  cursor.next();
  std::cout << "[OVAL] X : " << data["X"].data<float>() << std::endl;

  delete query;

  session->transaction().commit();
  delete session;
}
