#include <iostream>
#include <exception>
#include "GroupApp.h"
#include "CoralBase/Exception.h"

int main( int, char** )
{
  try {
    GroupApp app( "oracle://devdb10/RAL_WRITER", "ral_writer", "ral" );
    app.run();
  }
  catch ( coral::Exception& e ) {
    std::cerr << "CORAL Exception : " << e.what() << std::endl;
    return 1;
  }
  catch ( std::exception& e ) {
    std::cerr << "C++ Exception : " << e.what() << std::endl;
    return 1;
  }
  catch (...) {
    std::cerr << "Unknown exception ..." << std::endl;
    return 1;
  }
  std::cout << "[OVAL] Success" << std::endl;
  return 0;
}
