#include "ThreadApp.h"

#include "../Common/Reporter.h"

#include "CoralBase/Exception.h"

#include <iostream>
#include <exception>

int main( int, char** )
{
  Reporter reporter;
  try {
    ThreadApp app( "oracle://devdb10/RAL_WRITER", "ral_writer", "ral", reporter );
    app.run();
  }
  catch ( coral::Exception& e ) {
    reporter.reportToSTDERR( std::string( "CORAL Exception : " ) + std::string( e.what() ) );
    return 1;
  }
  catch ( std::exception& e ) {
    reporter.reportToSTDERR( std::string( "C++ Exception : " ) + std::string( e.what() ) );
    return 1;
  }
  catch (...) {
    reporter.reportToSTDERR( std::string( "Unknown Exception ..." )  );
    return 1;
  }
  reporter.reportToSTDOUT( std::string( "[OVAL] Success" )  );
  return 0;
}
