#ifndef THREADBODY_H
#define THREADBODY_H

#include <string>

namespace coral {
  class IConnection;
}

class Reporter;

class ThreadBody {

public:
  // Constructor
  ThreadBody( coral::IConnection& connection,
              int threadID,
              Reporter& reporter,
              const std::string& schemaName,
              const std::string& userName,
              const std::string& password );

  // Destructor
  virtual ~ThreadBody();

  // The thread body
  void operator()();

private:
  int                 m_threadID;
  Reporter&           m_reporter;
  coral::IConnection& m_connection;
  std::string         m_schemaName;
  std::string         m_userName;
  std::string         m_password;
};

#endif
