#include <iostream>
#include <exception>
#include "MultipleSessionsApp.h"
#include "../Common/Reporter.h"
#include "CoralBase/Exception.h"

int main( int, char** )
{
  Reporter reporter;
  try {
    MultipleSessionsApp app( "oracle://devdb10/ral_writer",
                             "ral_writer", "ral",
                             reporter );
    app.run();
  }
  catch ( coral::Exception& e ) {
    reporter.reportToSTDERR( std::string( "CORAL Exception : " ) + std::string( e.what() ) );
    return 1;
  }
  catch ( std::exception& e ) {
    reporter.reportToSTDERR( std::string( "C++ Exception : " ) + std::string( e.what() ) );
    return 1;
  }
  catch (...) {
    reporter.reportToSTDERR( std::string( "Unknown Exception ..." )  );
    return 1;
  }
  reporter.reportToSTDOUT( std::string( "[OVAL] Success" )  );
  return 0;
}
