#ifdef WIN32
// Keep the 'class sqlite3' forward declaration even if it is a struct
#pragma warning ( disable : 4099 )
#endif 

#include "SessionProperties.h"
#include "ConnectionProperties.h"
#include "DomainProperties.h"
#include "TypeConverter.h"
#include "RelationalAccess/ISession.h"
#include "RelationalAccess/ITransaction.h"
#include "sqlite3.h"
//#include <iostream>
coral::SQLiteAccess::SessionProperties::SessionProperties( coral::SQLiteAccess::ConnectionProperties& connectionProperties,coral::ISession& session,bool readOnly ):
  m_connectionProperties( connectionProperties ),
  m_session(session),
  m_monitoringService(0),
  //m_typeConverter( m_connectionProperties.typeConverter() ),
  m_isReadOnly( readOnly )
{}

coral::SQLiteAccess::SessionProperties::~SessionProperties()
{
}
const coral::SQLiteAccess::ConnectionProperties&
coral::SQLiteAccess::SessionProperties::connectionProperties() const
{
  return m_connectionProperties;
}
const coral::SQLiteAccess::DomainProperties&
coral::SQLiteAccess::SessionProperties::domainProperties() const
{
  return m_connectionProperties.domainProperties();
}
std::string
coral::SQLiteAccess::SessionProperties::connectionString() const
{
  return m_connectionString;
}

coral::ITypeConverter&
coral::SQLiteAccess::SessionProperties::typeConverter()
{
  return m_connectionProperties.typeConverter();
}

const coral::ITypeConverter&
coral::SQLiteAccess::SessionProperties::typeConverter() const
{
  return m_connectionProperties.typeConverter();
}

void 
coral::SQLiteAccess::SessionProperties::setdbHandle( sqlite3* dbHandle ){
  m_dbHandle=dbHandle;
}

sqlite3*
coral::SQLiteAccess::SessionProperties::dbHandle()
{
  return m_dbHandle;
}
sqlite3*
coral::SQLiteAccess::SessionProperties::dbHandle() const
{
  return m_dbHandle;
}

/*
int
coral::SQLiteAccess::SessionProperties::serverVersion() const
{
  return m_serverVersion;
}
*/
void
coral::SQLiteAccess::SessionProperties::setMonitoringService( coral::monitor::IMonitoringService* monitoringService )
{
  m_monitoringService = monitoringService;
}

coral::monitor::IMonitoringService*
coral::SQLiteAccess::SessionProperties::monitoringService() const
{
  return m_monitoringService;
}

coral::ISession&
coral::SQLiteAccess::SessionProperties::session()
{
  return m_session;
}

bool
coral::SQLiteAccess::SessionProperties::isReadOnly() const
{
  return m_isReadOnly;
}
inline std::string
coral::SQLiteAccess::SessionProperties::schemaName() const
{
  return "";
}

bool
coral::SQLiteAccess::SessionProperties::isTransactionActive() const
{
  return m_session.transaction().isActive();
}

coral::ISchema& 
coral::SQLiteAccess::SessionProperties::schema() const{
   return m_session.nominalSchema();
}
