#include<cppunit/extensions/HelperMacros.h>

#include "UnitTests/UnitTestBase.h"

#include "src/SQLiteExpressionParser.h"
#include <string>
#include <iostream>
class testParser: public CppUnit::TestFixture{
  CPPUNIT_TEST_SUITE( testParser );
  CPPUNIT_TEST( testparse );
  CPPUNIT_TEST_SUITE_END();
  coral::SQLiteAccess::SQLiteExpressionParser* m_parser;
public:
  void setUp(){
    std::cout<<"[OVAL] --> setUp"<<std::endl;
    m_parser=new coral::SQLiteAccess::SQLiteExpressionParser;
  }
  void testparse(){
    std::cout<<"[OVAL] --> testparse"<<std::endl;
    std::string result;
    std::vector<std::string> outlist;
    outlist.push_back("cola");
    outlist.push_back("colb");
    m_parser->addToTableList("","mytab",outlist);
    result=m_parser->parseExpression("select cola from mytab where cola=4");
    std::cout<<"result "<<result<<std::endl;
    result=m_parser->parseExpression("insert into mytab values(:x, :y, :z)");
    std::cout<<"result "<<result<<std::endl;
    result=m_parser->parseExpression("select colb from mytab where colb=':a' ");
    std::cout<<"result "<<result<<std::endl;
    result=m_parser->parseExpression("select colb from mytab where colb=:a ");
    std::cout<<"result "<<result<<std::endl;
    result=m_parser->parseExpression("select colb from mytab where colb>=6 ");
    std::cout<<"result "<<result<<std::endl;

    result=m_parser->parseExpression("update mytab.colb set cola=:a where colb>=:b ");
    std::cout<<"result "<<result<<std::endl;

  }
  void tearDown(){
    std::cout << "[OVAL] --> tearDown" << std::endl;
    delete m_parser;
  }
};
CPPUNIT_TEST_SUITE_REGISTRATION( testParser );

int main ()
{
	return coral::UnitTests::run();
}


