#include "TestCore.h"
#include "TestEnv.h"
#include "Testing.h"
#include "TestingConfig.h"

int main()
{
	TestEnv* _testEnv = new TestEnv("BASIS");
	_testEnv->addDBType("oracle");
	_testEnv->addServiceName(0, TEST_CORE_SCHEME_ADMIN);
	
	coral::ConnectionService * connService = new coral::ConnectionService();
	std::string serviceName = _testEnv->getServiceName(0);
	coral::ISessionProxy* session = connService->connect( serviceName, coral::Update );
	
	if ( ! session ) throw std::runtime_error( "Could not connect to " + serviceName );
	 
	session->transaction().start();
	coral::ISchema& schema = session->nominalSchema();
	
	//schema.callProcedure("atyala", coral::AttributeList());
	schema.callProcedure("atyala.patyala", coral::AttributeList());
	
	return 1;
}