#include "Connection.h"
#include "RelationalAccess/ConnectionService.h"
#include "RelationalAccess/IConnectionServiceConfiguration.h"
#include <stdexcept>
#include "RelationalAccess/ISession.h"
#include "RelationalAccess/ITransaction.h"
#include "RelationalAccess/ISchema.h"
#include <stdexcept>
#include <iostream>
#include <string>
#include <set>

Connection::Connection(const char * testName) : TestEnv(testName)
{
  getTableString(T1, "T1");
}

Connection::~Connection()
{
}

void
Connection::Init()
{
  coral::ConnectionService connServ;
  coral::IConnectionServiceConfiguration& config = connServ.configuration();
  config.setConnectionRetrialPeriod(2);
  config.setConnectionRetrialTimeOut(20);
}
  
coral::ISessionProxy* Connection::getSessionProxy( int connIndex, coral::AccessMode mode)
{
  coral::ConnectionService connServ;
  coral::ISessionProxy * proxy = NULL;
  if(mode == coral::ReadOnly){
    proxy = connServ.connect(getServiceName(connIndex, TESTENV_READER), mode );
  }else{
    proxy = connServ.connect(getServiceName(connIndex), mode );  
  }
  return proxy;
}  

void
Connection::listTables(coral::ISessionProxy * proxy)
{
    proxy->transaction().start();
    std::cout << "Tables in the schema: " << T1 <<std::endl;
    std::set< std::string > listOfTables = proxy->nominalSchema().listTables();
    for ( std::set< std::string >::const_iterator iTable = listOfTables.begin();
          iTable != listOfTables.end(); ++iTable ) std::cout << *iTable << std::endl;
    proxy->transaction().commit();
}    
