#include "TestApp.h"
#include "CoralBase/Exception.h"
#include <iostream>
#include <exception>
#include <cstdlib>


int main( int argc, char *argv[] )
{
  TestApp app("CS_REPLICAEXCLUDING");
  
  app.addWriters().addDefault("oracle");

  if(app.check(argc, argv)){
  
    app.addServiceName(0, TEST_CORE_SCHEME_ADMIN);
    
    app.addServiceName(0, TEST_CORE_REPLICA_EXCLUDING_0);  
    app.addServiceName(0, TEST_CORE_REPLICA_EXCLUDING_1);  
    app.addServiceName(0, TEST_CORE_REPLICA_EXCLUDING_2);  
    try {
       
      app.run();
    }
    catch ( coral::Exception& e )
    {
      std::cerr << "CORAL exception " << e.what() << std::endl;
      return 1;
    }
    catch ( std::exception& e )
    {
      std::cerr << "Standard C++ exception " << e.what() << std::endl;
      return 1;
    }
    catch( ... )
    {
      std::cerr << "Unknown exception ..." << std::endl;
      return 1;
    }
    std::cout << "[OVAL] Success" << std::endl;
    return 0;
  }
  return 1;
}
