#ifndef INCLUDE_TESTAPP_H
#define INCLUDE_TESTAPP_H

#include "Testing.h"

// Disable warnings triggered by the CppUnit headers
// See http://wiki.services.openoffice.org/wiki/Writing_warning-free_code
// See also http://www.artima.com/cppsource/codestandards.html
#if defined __GNUC__
#pragma GCC system_header
#endif

// Include files

// from SPI version of the testdriver
#include <cppunit/extensions/TestFactoryRegistry.h> 
#include <cppunit/TextTestRunner.h> 
#include <cppunit/CompilerOutputter.h> 
#include <cppunit/TextOutputter.h> 
#include <cppunit/XmlOutputter.h> 

// to produce one line per test
#include <cppunit/TestResult.h>
//#include <cppunit/BriefTestProgressListener.h>
//#include <cppunit/TestResultCollector.h>

// needed by the implementation of cool::ProgressListener
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestListener.h>

// provides macros for the tests
#include <cppunit/extensions/HelperMacros.h>

#include "CoralBase/Attribute.h"
#include "CoralBase/AttributeList.h"

//typedef std::pair<std::string, cool::StorageType::TypeId> FieldSpecification;

//typedef std::vector<FieldSpecification> RecordSpecification;

class TestApp : public Testing, CppUnit::TestFixture
{
public:
  // Constructor
  TestApp(TestEnv * env);
  // Destructor
  ~TestApp();
  // run method
//  static const coral::AttributeList& referenceData(int index);
//  static const RecordSpecification& referenceRecordSpec();
  void fillReferencedData();
  void readReferencedData();
  
  void testsQueries();
  void testsAttrLists();

};

#endif
