#ifndef CORAL_TESTING_APPLICATION_BASE
#define CORAL_TESTING_APPLICATION_BASE

#include "TestEnv/SealSwitch.h"

namespace coral {

  class IConnectionService;


  namespace Testing {

    class ApplicationBase
    {
    public:
      /// Constructor
      ApplicationBase();

      /// Destructor
      virtual ~ApplicationBase();

      /// Runs the application
      void run();

    protected:
      
      SealSwitcher m_sw;
      /// Returns the connection service
      coral::IConnectionService& connectionService();

      /// Performs the first read operation
      virtual void read1();

      /// Performs the second read operation
      virtual void read2();
    };

  }

}


#endif
