#include "Connectivity/ApplicationBase.h"

#include "RelationalAccess/IConnectionService.h"

#include <iostream>
#include <cstdlib>

coral::Testing::ApplicationBase::ApplicationBase()
{

  if ( ! ::getenv( "CORAL_AUTH_PATH" ) ) {
    ::putenv( const_cast<char*>("CORAL_AUTH_PATH=/afs/cern.ch/sw/lcg/app/pool/db/connectivity_tests") );
  }

  if ( ! ::getenv( "CORAL_DBLOOKUP_PATH" ) ) {
    ::putenv( const_cast<char*>("CORAL_DBLOOKUP_PATH=/afs/cern.ch/sw/lcg/app/pool/db/connectivity_tests") );
  }

  m_sw.loadComponent( "CORAL/Services/ConnectionService" );
}

coral::Testing::ApplicationBase::~ApplicationBase()
{
}

coral::IConnectionService& coral::Testing::ApplicationBase::connectionService()
{
  return m_sw.getConnectionService();
}


void
coral::Testing::ApplicationBase::run()
{
  std::cout << "First read operation starts" << std::endl;
  this->read1();
  std::cout << "First read operation ended" << std::endl << std::endl;

  std::cout << "Type ENTER to continue to second read operation" << std::endl;
  std::cin.get();
  std::cout << "Second read operation starts" << std::endl;
  this->read2();
  std::cout << "Second read operation ended" << std::endl;
}


void
coral::Testing::ApplicationBase::read1()
{
}

void
coral::Testing::ApplicationBase::read2()
{
}
