#include "Connectivity/ApplicationFactory.h"
#include "DataFiller.h"
#include "Reader.h"
#include "Reader2.h"


coral::Testing::ApplicationFactory&
coral::Testing::ApplicationFactory::instance()
{
  static ApplicationFactory s_factory;
  return s_factory;
}


coral::Testing::ApplicationBase*
coral::Testing::ApplicationFactory::application( const std::string& testName,
                                                 const std::string& args )
{
  if ( testName == "FillData" )
    return new coral::Testing::DataFiller;
  else if ( testName == "ReadData" )
    return new coral::Testing::Reader( args );
  else if ( testName == "ReadData2" )
    return new coral::Testing::Reader2( args );
  else
    return new coral::Testing::ApplicationBase;
}


coral::Testing::ApplicationFactory::ApplicationFactory()
{}
