#ifndef TESTCORE_TESTCORE_H
#define TESTCORE_TESTCORE_H 1

#include "CoralKernel/Context.h"
#include "RelationalAccess/IMonitoringService.h"
#include "RelationalAccess/AccessMode.h"

#include "CoralCommon/Utilities.h"

#include "CoralBase/Exception.h"

#include <stdexcept>
#include <sstream>
#include <cfloat>
#include <cmath>
#include <iostream>

#include "TestEnv.h"


namespace coral {
  class IConnectionService;
  class ISessionProxy;
  class IConnectionServiceConfiguration;
  class ConnectionService;
}

class TestCore : public TestEnv {
public:
    //constructor
    TestCore(const char * testName);
    //destructor
    ~TestCore();
    //create a session with coral::update mode
    coral::ISessionProxy * createSession(int index);
    //create a session with custom mode
    coral::ISessionProxy * createSession(int index, coral::AccessMode mode);
    //create a session with a handle
    coral::ISessionProxy * createSession(int index, coral::IHandle<coral::IConnectionService> handle, coral::AccessMode mode);
    //load monitoring component
    void monitoringLoad();
    //start monitoring level
    void monitoringStart(coral::monitor::Level level);
    //stop monitoring level
    void monitoringStop();
    //get reporter
    const coral::IMonitoringReporter& getMonitoringReporter();
    //get connection configuration
    coral::IConnectionServiceConfiguration& getConnectionConfig();
    //get the context
    coral::Context& getContext();
  
private:   
    //serviceName of the current session 
    std::string serviceName;
    
    coral::ConnectionService * connService;
};

#endif
