#ifndef TESTCORE_TESTENV_H
#define TESTCORE_TESTENV_H 1

#include <string>
#include <vector>
#include <iostream>

#define ALEXS_CONFIG

#ifdef ALEXS_CONFIG

#define TEST_CORE_SCHEME_ADMIN "admin"
#define TEST_CORE_SCHEME_READER "reader"
#define TEST_CORE_SCHEME_WRITER "writer"

#define TEST_CORE_SERVICE_0 "service_0"
#define TEST_CORE_SERVICE_1 "service_1"
#define TEST_CORE_SERVICE_2 "service_2"
#define TEST_CORE_SERVICE_3 "service_3"

#define TEST_CORE_REPLICA_SERVICE_0 "replica_0"
#define TEST_CORE_REPLICA_SERVICE_1 "replica_1"
#define TEST_CORE_REPLICA_SERVICE_2 "replica_2"
#define TEST_CORE_REPLICA_SERVICE_3 "replica_3"
#define TEST_CORE_REPLICA_SERVICE_4 "replica_4"

#define TEST_CORE_REPLICA_EXCLUDING_0 "replica_excluding_0"
#define TEST_CORE_REPLICA_EXCLUDING_1 "replica_excluding_1"
#define TEST_CORE_REPLICA_EXCLUDING_2 "replica_excluding_2"

#define TEST_CORE_DEVSERVICE_0 "devservice_0"
#define TEST_CORE_DEVSERVICE_1 "devservice_1"

#else

#endif

class TestEnvDBType {
public:
    //constructor
    TestEnvDBType();
    //destructor
    ~TestEnvDBType();
    //add a db type
    TestEnvDBType& add(const std::string& dbType);
    //set the type
    void setType(const char* dbType);
    //get the current type
    std::string& getType();
    //some transform functions
    std::string& toString();
    std::string& toXML();
private:
    //vector with all supported dbtypes
    std::vector<std::string*> dbTypes;
    //the current position
    int currentType;
    //buffer
    std::string buffer;
};

class TestEnv {
public:
    //constructor
    TestEnv(const char * testName);
    //destructor
    ~TestEnv();
    //add a supported db type
    TestEnvDBType& addDBType(const std::string& dbType);
    //check the environment and program parameters
    bool check(int argc, char * argv[]);
    //get dbtype
    std::string& getDBType(int pos);
    //get table name
    std::string& getTableString(std::string& source, const std::string& tableName);   
    //get the service name
    std::string& getServiceName(int index);
        
    //setup additionell arguments
    void addServiceName(int pos, const std::string& type);
    
    
protected:
    //name
    std::string testCoreName;

    std::vector<std::string*> addArgs;

private:
    //get the service name
    std::string* getServiceNamePtr(int index);
    
    std::vector<TestEnvDBType*> DBTypes;
    
    std::string empty;
    
    std::string platformPrefix;
    
    std::string slotPrefix;

};



#endif
