#ifndef TESTCORE_TESTENV_H
#define TESTCORE_TESTENV_H 1

#define TEST_CORE_SCHEME_ADMIN "admin"
#define TEST_CORE_SCHEME_READER "reader"
#define TEST_CORE_SCHEME_WRITER "writer"

#define TEST_CORE_SERVICE_0 "service_0"
#define TEST_CORE_SERVICE_1 "service_1"
#define TEST_CORE_SERVICE_2 "service_2"
#define TEST_CORE_SERVICE_3 "service_3"

#define TEST_CORE_REPLICA_SERVICE_0 "replica_0"
#define TEST_CORE_REPLICA_SERVICE_1 "replica_1"
#define TEST_CORE_REPLICA_SERVICE_2 "replica_2"
#define TEST_CORE_REPLICA_SERVICE_3 "replica_3"
#define TEST_CORE_REPLICA_SERVICE_4 "replica_4"

#define TEST_CORE_REPLICA_EXCLUDING_0 "replica_excluding_0"
#define TEST_CORE_REPLICA_EXCLUDING_1 "replica_excluding_1"
#define TEST_CORE_REPLICA_EXCLUDING_2 "replica_excluding_2"

#define TEST_CORE_DEVSERVICE_0 "devservice_0"
#define TEST_CORE_DEVSERVICE_1 "devservice_1"

#include <string>

#include "TestEnvWriters.h"

#define TESTENV_WRITER false
#define TESTENV_READER true

class TestEnv {
public:
    //constructor
    TestEnv(std::string testName);
    //destructor
    ~TestEnv();
    //add a new writers group
    TestEnvWriters& addWriters();
    //check environment and program parameters
    bool check(int argc, char * argv[]);
    //set a service name
    size_t addServiceName(size_t pos, const std::string writerexp, const std::string readerexp = "");
    //get the service name using the index
    const std::string getServiceName(size_t index, bool reader = TESTENV_WRITER) const;
    //get the backend
    const std::string getDBType(size_t pos, bool reader = TESTENV_WRITER) const;
    //get table name
    const std::string& getTableString(std::string& source, const std::string& tableName) const;

private:
    void setupUserInput(int argc, char * argv[]);

    std::vector<TestEnvWriters*> m_writers;

    std::string m_testName;
    
    std::vector< std::pair<std::string, std::string> > m_services;
    
    std::string m_platformPrefix;
    
    std::string m_slotPrefix;


};

#endif
