#! /usr/bin/env python
# $Id: client.py,v 1.5 2007/12/10 16:33:47 rbasset Exp $

from platform import node
import csv, threading

class Client(threading.Thread):
  """ Extend the abstract class Client to create a simulation client. """

  _reportFile = ""
  _errorFile = ""
  _reportPeriod = 10
  
  def __init__(self, logFile="client", reportPeriod=10, **kw):
    self._reportFile = logFile+".csv"
    self._errorFile  = logFile+".err"
    self._reportPeriod = reportPeriod
    threading.Thread.__init__(self, **kw)
    
  def logReport(self, report):
    """ Writes a array of values in the result file (csv). """ 
    # open and close the file each time in order to trigger an AFS synchronization
    f = open(self._reportFile, 'a')
    csv_writer = csv.writer(f, delimiter=';')
    csv_writer.writerow(report)
    f.close()
    
  def logError(self, error):
    """ Writes a message in the error file. """
    f = open(self._errorFile, 'a')
    f.write(error + '\n')
    f.close()
  
  def run(self):
    raise NotImplementedError

