#! /usr/bin/env python
# $Id: lemonData.py,v 1.2 2007/12/07 14:02:15 rbasset Exp $
from os import getenv, sep
from urllib2 import urlopen
from re import search

class LemonData(object):
   
   _baseUrl = "http://lemonweb.cern.ch/lemon-web/"
   _mainPage = "info.php?type=host&detailed=yes"
   _metricPage = "metric_graph.php?type=host&entity="
   _imagePattern = r'cache/jpgraph\w+'

   def __init__(self, directory, sdate, sdate_time, edate, edate_time):
      self._verbose = getenv('PERF_VERBOSE')
      self._dates = '&sdate='+sdate+'&sdate_time='+sdate_time+'&edate='+edate+'&edate_time='+edate_time
      self._directory = directory

   def fetchHostImg(self, host):
      """ Download different graphes from LEMON web pages 
      for a specific host. """
      metricField = [['networkInterfaceI0','NUMKBREADAVG'], \
                     ['networkInterfaceI0','NUMKBWRITEAVG'], \
                     ['CPUutil','PercIdle'], \
                     ['LoadAvg','LOADAVG']]
      url = self._baseUrl + self._metricPage + host + self._dates
      
      for [metric,field] in metricField:
         imgUrl = url+'&metric='+metric+'&field='+field
	 fileName = self._directory+sep+host+'_'+metric+'_'+field+'.png'
         imgQuery = self.fetchImg(imgUrl, fileName)
   
   def fetchImg(self, url, fileName):
      sock = urlopen(url)
      m = None
      for src in sock:
         m = search(self._imagePattern, src)
         if (m != None) :
	    break
      sock.close()
      
      if (m!= None):
         imgName = m.group()
         sock = urlopen(self._baseUrl+imgName)
         imgBin = sock.read()
         imgFile = open(fileName,'wb')
         imgFile.write(imgBin)
         imgFile.close()
         sock.close()


