#! /usr/bin/env python
# $Id: createCoolDb.py,v 1.2 2007/11/27 10:19:11 rbasset Exp $

from PyCool import cool
from coolSetup import CoolSetup

class CreateCoolDb:

	def folderName(self, iFolder):
	    fName = "/f" + repr(iFolder).zfill(3)
	    return fName

	def createDb(self):
	    dbSvc = cool.DatabaseSvcFactory.databaseService()

	    print("Drop the test database")
	    dbSvc.dropDatabase( CoolSetup.connectString )
	    print("Done")

	    print("Create the test database")
	    db = dbSvc.createDatabase( CoolSetup.connectString )
	    print("Database created !")

	    print("Create the folders")
	    for iFolder in range(1, CoolSetup.nFolders+1):
		fName = self.folderName(iFolder)
		f = db.createFolder\
		    ( fName, CoolSetup.spec, "SV folder", cool.FolderVersioning.SINGLE_VERSION )
	        if (iFolder%10==0):
	            print(str(iFolder)+" folders created")
	    print("All the folders have been created")

	    db.closeDatabase()


if __name__ == '__main__':
	client = CreateCoolDb()
	client.createDb()

