#! /usr/bin/env python
# $Id: startClients.py,v 1.17 2007/12/10 16:33:47 rbasset Exp $
""" Start test clients on one specific node """

import os
import sys
from time import sleep, time

# python startClients.py
if __name__ == '__main__':
	if len(sys.argv) != 4:
		print "Usage: startClients.py <hostName> <clientIdOffset> <logDirNamePath>"
		sys.exit()

	# Loads config parameters
	from config import Config
	cfg = Config().config

	reportPeriod = cfg['reportPeriod']
	logFileModel = sys.argv[3] + "/log_" + sys.argv[1] + "_"
	numClientsStarted = 0
	idOffset = int(sys.argv[2])
	numClientsToStart = cfg['numClientsPerBoxInit']

	while (numClientsStarted < cfg['numMaxClientsPerBox']):
		lastStart = time()
		for i in range(numClientsToStart):
			numClientsStarted += 1
			logFile = logFileModel + str(idOffset + numClientsStarted)

			if cfg['testClientExe'] == 'python':
				# the client script is written in python,
				# it can access globals variables (cfg, reportPeriod, logFile)
				execfile(cfg['testClientCmd'])
			else:
				# then the client is not a python script
				clientCmd = cfg['baseDir']+"bin/"+cfg['testClientCmd']
				clientCmdArg  = [cfg['testClientCmd']]
				clientCmdArg += [str(idOffset + numClientsStarted)]
				clientCmdArg += [str(reportPeriod)]
				clientCmdArg += [logFile]
				os.spawnvp(os.P_NOWAIT, clientCmd, clientCmdArg)

		numClientsToStart = cfg['numClientsPerStep']
		sleepTime = cfg['stepPeriod'] - (time() - lastStart)
		if sleepTime > 0:
			sleep(sleepTime)

