<?php

include ("../jpgraph/src/jpgraph.php");
include ("../jpgraph/src/jpgraph_line.php");
include ("../jpgraph/src/jpgraph_date.php");

include ("jpgraphdata/cpudata.php");
include ("jpgraphdata/xdata.php");

$graph = new Graph(800,400,"auto");
$graph->SetScale("datlin");
$graph->img->SetAntiAliasing();
$graph->SetMargin(40,20,20,90);
$graph->SetMarginColor('white'); 

$lineplot1=new LinePlot($maxcpudata, $xdata);
$lineplot2=new LinePlot($avgcpudata, $xdata);
$lineplot3=new LinePlot($mincpudata, $xdata);

$lineplot1->SetColor("red");
$lineplot2->SetColor("blue");
$lineplot3->SetColor("green");

$lineplot1->SetLegend("Maximum");
$lineplot2->SetLegend("Average");
$lineplot3->SetLegend("Minimum");

$graph->Add($lineplot1);
$graph->Add($lineplot2);
$graph->Add($lineplot3);

$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->title->Set("Database Server CPU Host Utilisation");
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->SetTitle("Timeline","middle");
$graph->xaxis->SetLabelAngle(90);
$graph->xaxis->scale->SetDateFormat('H:i:s');
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetTitle("CPU Utilization (%)","middle");

$graph->legend->Pos(0.5,0.99,"center","bottom");
$graph->legend->SetLayout(LEGEND_HOR);
$graph->Stroke();

?>

