<?php

include ("../jpgraph/src/jpgraph.php");
include ("../jpgraph/src/jpgraph_line.php");
include ("../jpgraph/src/jpgraph_date.php");

include ("jpgraphdata/waitdata.php");
include ("jpgraphdata/xdata.php");

$colors = array("limegreen","palegreen","blue","deepskyblue","firebrick","red","orange3","brown4","darkgray","lightgoldenrod3","lemonchiffon2","deeppink");

// Create the graph. These two calls are always required
$graph = new Graph(800,400,"auto");    
$graph->SetScale("datlin");
$graph->img->SetAntiAliasing();
$graph->SetMargin(40,140,20,70);
$graph->SetMarginColor('white'); 

// Create the linear plots for each category
for($i=0; $i < count($waitdata); $i++){
   $dplot[] = new LinePlot($waitdata[$i], $xdata);
   $dplot[$i]->SetFillColor($colors[$i]);
   $dplot[$i]->SetLegend($waitheaders[$i]);
   $dplot[$i]->SetWeight(0);
}

// Create the accumulated graph
$accplot = new AccLinePlot($dplot);

// Add the plot to the graph
$graph->Add($accplot);

$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->title->Set("Average Active Sessions");
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->SetTitle("Timeline","middle");
$graph->xaxis->SetLabelAngle(90);
$graph->xaxis->scale->SetDateFormat('H:i:s');
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetTitle("Sessions actives","middle");

// Adjust the legend position
$graph->legend->Pos(0.01,0.5,"right","center");
$graph->legend->SetReverse(); 

// Display the graph
$graph->Stroke();
?>

