#ifndef TESTS_UNITTESTBASE_H_
#define TESTS_UNITTESTBASE_H_

#include <boost/preprocessor/control/iif.hpp>
#include <boost/preprocessor/seq.hpp>

#include "cppunit_wrapper.h"

#define TESTBASE_TESTDEF(r,data,t) CPPUNIT_TEST (t);
#define TESTBASE_METHODEF(r,data,t) void t(void);

namespace coral {

namespace UnitTests {

/** Run a whole CppUnit test suite.
 * 
 * Before calling those functions, register all the test classes by using
 * 
 * CPPUNIT_TEST_SUITE_REGISTRATION (TestImplementationClass);
 * 
 * macro for each test classes.
 */
int run();

} // namespace MySQLAccess

} // namespace coral

#endif /*TESTS_UNITTESTBASE_H_*/
